unit fOMVerify;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  fAutoSz, StdCtrls, ComCtrls;

type
  TfrmOMVerify = class(TfrmAutoSz)
    cmdAccept: TButton;
    cmdEdit: TButton;
    cmdCancel: TButton;
    memText: TRichEdit;
    procedure cmdAcceptClick(Sender: TObject);
    procedure cmdEditClick(Sender: TObject);
    procedure cmdCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FLevel: Integer;
  end;

procedure ShowVerifyText(var QuickLevel: Integer; const VerifyText: string);

implementation

{$R *.DFM}

uses ORFn, uConst, fFrame, rMisc;

procedure ShowVerifyText(var QuickLevel: Integer; const VerifyText: string);
var
  frmOMVerify: TfrmOMVerify;
begin
  frmOMVerify := TfrmOMVerify.Create(Application);
  try
    ResizeFormToFont(TForm(frmOMVerify));
    with frmOMVerify do
    begin
      SetBounds(frmFrame.Left, frmFrame.Top + frmFrame.Height - Height, Width, Height);
      SetFormPosition(frmOMVerify);
      memText.Lines.SetText(PChar(VerifyText));
      ShowModal;
      QuickLevel := FLevel;
    end;
  finally
    frmOMVerify.Release;
  end;
end;


procedure TfrmOMVerify.FormCreate(Sender: TObject);
begin
  inherited;
  FLevel := QL_CANCEL;
end;

procedure TfrmOMVerify.cmdAcceptClick(Sender: TObject);
begin
  inherited;
  FLevel := QL_AUTO;
  Close;
end;

procedure TfrmOMVerify.cmdEditClick(Sender: TObject);
begin
  inherited;
  FLevel := QL_DIALOG;
  Close;
end;

procedure TfrmOMVerify.cmdCancelClick(Sender: TObject);
begin
  inherited;
  FLevel := QL_CANCEL;
  Close;
end;

procedure TfrmOMVerify.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  inherited;
  SaveUserBounds(Self);
end;

end.
