unit fOrdersCopy;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  fAutoSz, StdCtrls, ORCtrls;

type
  TfrmCopyOrders = class(TfrmAutoSz)
    radRelease: TRadioButton;
    radDelay: TRadioButton;
    GroupBox1: TGroupBox;
    lstOrderSheet: TORListBox;
    cmdOK: TButton;
    cmdCancel: TButton;
    procedure cmdOKClick(Sender: TObject);
    procedure cmdCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure radClick(Sender: TObject);
  private
    OKPressed: Boolean;
  public
    { Public declarations }
  end;

function SetViewForCopy: Boolean;

implementation

{$R *.DFM}

uses fOrders, ORFn;

const
  TX_EVENT_REQD = 'An event for which orders should be delayed must be selected.';
  TC_EVENT_REQD = 'Selection Required';

function SetViewForCopy: Boolean;
var
  frmCopyOrders: TfrmCopyOrders;
  i: Integer;
begin
  Result := False;
  frmCopyOrders := TfrmCopyOrders.Create(Application);
  try
    ResizeFormToFont(TForm(frmCopyOrders));
    with frmOrders.lstSheets do for i := 0 to Items.Count - 1 do
    begin
      if CharAt(Items[i], 1) <> 'C' then frmCopyOrders.lstOrderSheet.Items.Add(Items[i]);
    end;
    frmCopyOrders.ShowModal;
    if frmCopyOrders.OKPressed then
    begin
      Result := True;
    end;
  finally
    frmCopyOrders.Release;
  end;
end;

procedure TfrmCopyOrders.FormCreate(Sender: TObject);
begin
  inherited;
  OKPressed := False;
end;

procedure TfrmCopyOrders.cmdOKClick(Sender: TObject);
begin
  inherited;
  if radRelease.Checked then
  begin
    frmOrders.lstSheets.ItemIndex := 0;              // check to make sure ItemID = 'C'?
    frmOrders.lstSheetsClick(Self);
  end;
  if radDelay.Checked then
  begin
    if lstOrderSheet.ItemIndex < 0 then
    begin
      InfoBox(TX_EVENT_REQD, TC_EVENT_REQD, MB_OK);
      Exit;
    end;
    frmOrders.lstSheets.SelectByID(lstOrderSheet.ItemID);
    frmOrders.lstSheetsClick(Self);
    if frmOrders.lstSheets.ItemIndex < 1 then        // check to make sure not = 'C'?
    begin
      InfoBox(TX_EVENT_REQD, TC_EVENT_REQD, MB_OK);
      Exit;
    end;
  end;
  OKPressed := True;
  Close;
end;

procedure TfrmCopyOrders.cmdCancelClick(Sender: TObject);
begin
  inherited;
  Close;
end;

procedure TfrmCopyOrders.radClick(Sender: TObject);
begin
  inherited;
  lstOrderSheet.Enabled := radDelay.Checked;
  if not lstOrderSheet.Enabled then lstOrderSheet.ItemIndex := -1;
end;

end.
