unit fOrdersTS;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  fAutoSz, StdCtrls, ORCtrls, ORFn;

type
  TfrmOrdersTS = class(TfrmAutoSz)
    lblInstruct: TLabel;
    lblSpecialty: TLabel;
    cboSpecialty: TORComboBox;
    cmdOK: TButton;
    cmdCancel: TButton;
    procedure cmdOKClick(Sender: TObject);
    procedure cmdCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    OKPressed: Boolean;
  end;

procedure SelectTreatingSpecialty(EventType: Char; var ASpecialty: Integer;
  var ASpecialtyName: string);

implementation

uses rOrders;

{$R *.DFM}

const
  TX_TRANSFER = 'The release of orders entered while the "Transfer" order sheet is ' +
                'selected will be delayed until the patient is transferred to the ' +
                'following specialty.';
  TX_ADMIT    = 'The release of orders entered while the "Admit" order sheet is ' +
                'selected will be delayed until the patient is admitted to the ' +
                'following specialty.';

procedure SelectTreatingSpecialty(EventType: Char; var ASpecialty: Integer;
  var ASpecialtyName: string);
var
  frmOrdersTS: TfrmOrdersTS;
begin
   ASpecialty := 0;
   ASpecialtyName := '';
  frmOrdersTS := TfrmOrdersTS.Create(Application);
  try
    ResizeFormToFont(TForm(frmOrdersTS));
    if EventType = 'A' then
    begin
      frmOrdersTS.lblInstruct.Caption := TX_ADMIT;
      frmOrdersTS.lblSpecialty.Caption := 'Admit to Specialty';
    end else
    begin
      frmOrdersTS.lblInstruct.Caption := TX_TRANSFER;
      frmOrdersTS.lblSpecialty.Caption := 'Transfer to Specialty';
    end;
    ListSpecialties(frmOrdersTS.cboSpecialty.Items);
    frmOrdersTS.ShowModal;
    if frmOrdersTS.OKPressed then
    begin
      ASpecialty     := frmOrdersTS.cboSpecialty.ItemIEN;
      ASpecialtyName := frmOrdersTS.cboSpecialty.Text;
    end;
  finally
    frmOrdersTS.Release;
  end;
end;

procedure TfrmOrdersTS.FormCreate(Sender: TObject);
begin
  inherited;
  OKPressed := False;
end;

procedure TfrmOrdersTS.cmdOKClick(Sender: TObject);
begin
  inherited;
  if not (cboSpecialty.ItemIEN > 0) then
  begin
    InfoBox('A treating specialty has not been selected.', 'No Selection Made', MB_OK);
    Exit;
  end;
  OKPressed := True;
  Close;
end;

procedure TfrmOrdersTS.cmdCancelClick(Sender: TObject);
begin
  inherited;
  Close;
end;

end.
