unit fFrame;
{ This is the main form for the CPRS GUI.  It provides a patient-encounter-user framework
  which all the other forms of the GUI use. }

{$OPTIMIZATION OFF}                              // REMOVE AFTER UNIT IS DEBUGGED

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Tabs, ComCtrls,
  ExtCtrls, Menus, StdCtrls, Buttons, ORFn, fPage, uConst, ORCtrls;

type
  TfrmFrame = class(TForm)
    pnlToolbar: TPanel;
    stsArea: TStatusBar;
    tabPage: TTabSet;
    pnlPage: TPanel;
    bvlPageTop: TBevel;
    bvlToolTop: TBevel;
    pnlPatient: TPanel;
    lblPtName: TLabel;
    lblPtSSN: TLabel;
    lblPtAge: TLabel;
    pnlVisit: TPanel;
    lblPtLocation: TLabel;
    lblPtProvider: TLabel;
    pnlPostings: TPanel;
    lblPtPostings: TLabel;
    lblPtCWAD: TLabel;
    mnuFrame: TMainMenu;
    mnuFile: TMenuItem;
    mnuFileExit: TMenuItem;
    mnuFileOpen: TMenuItem;
    mnuFileReview: TMenuItem;
    Z1: TMenuItem;
    mnuFilePrint: TMenuItem;
    Z2: TMenuItem;
    mnuEdit: TMenuItem;
    mnuEditUndo: TMenuItem;
    Z3: TMenuItem;
    mnuEditCut: TMenuItem;
    mnuEditCopy: TMenuItem;
    mnuEditPaste: TMenuItem;
    Z4: TMenuItem;
    mnuEditPref: TMenuItem;
    Prefs1: TMenuItem;
    mnu24pt1: TMenuItem;
    mnu18pt1: TMenuItem;
    mnu14pt1: TMenuItem;
    mnu12pt1: TMenuItem;
    mnu10pt1: TMenuItem;
    mnu8pt: TMenuItem;
    mnuHelp: TMenuItem;
    mnuHelpContents: TMenuItem;
    mnuHelpTutor: TMenuItem;
    Z5: TMenuItem;
    mnuHelpAbout: TMenuItem;
    mnuTools: TMenuItem;
    mnuView: TMenuItem;
    mnuViewChart: TMenuItem;
    mnuChartReports: TMenuItem;
    mnuChartLabs: TMenuItem;
    mnuChartDCSumm: TMenuItem;
    mnuChartCslts: TMenuItem;
    mnuChartNotes: TMenuItem;
    mnuChartOrders: TMenuItem;
    mnuChartMeds: TMenuItem;
    mnuChartProbs: TMenuItem;
    mnuChartCover: TMenuItem;
    mnuHelpBroker: TMenuItem;
    mnuFileEncounter: TMenuItem;
    mnuViewDemo: TMenuItem;
    mnuViewPostings: TMenuItem;
    mnuHelpLists: TMenuItem;
    Z6: TMenuItem;
    mnuHelpSymbols: TMenuItem;
    mnuFileNext: TMenuItem;
    Z7: TMenuItem;
    mnuFileRefresh: TMenuItem;
    pnlPrimaryCare: TPanel;
    lblPtCare: TLabel;
    lblPtAttending: TLabel;
    pnlCIRN: TPanel;
    lblCIRN: TLabel;
    lblCIRNData: TLabel;
    pnlReminders: TPanel;
    imgReminder: TImage;
    mnuViewReminders: TMenuItem;
    anmtRemSearch: TAnimate;
    lstCIRNLocations: TORListBox;
    popCIRN: TPopupMenu;
    popCIRNSelectAll: TMenuItem;
    popCIRNSelectNone: TMenuItem;
    popCIRNClose: TMenuItem;
    mnuFilePrintSetup: TMenuItem;
    LabInfo1: TMenuItem;
    mnuFileNotifRemove: TMenuItem;
    Z8: TMenuItem;
    mnuToolsOptions: TMenuItem;
    mnuChartSurgery: TMenuItem;
    procedure tabPageChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure pnlPatientMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pnlPatientMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pnlVisitMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pnlVisitMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuFileExitClick(Sender: TObject);
    procedure pnlPostingsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pnlPostingsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuFontSizeClick(Sender: TObject);
    procedure mnuChartTabClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mnuFileOpenClick(Sender: TObject);
    procedure mnuHelpBrokerClick(Sender: TObject);
    procedure mnuFileEncounterClick(Sender: TObject);
    procedure mnuViewDemoClick(Sender: TObject);
    procedure mnuViewPostingsClick(Sender: TObject);
    procedure mnuHelpAboutClick(Sender: TObject);
    procedure mnuFileReviewClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mnuHelpListsClick(Sender: TObject);
    procedure ToolClick(Sender: TObject);
    procedure mnuEditClick(Sender: TObject);
    procedure mnuEditUndoClick(Sender: TObject);
    procedure mnuEditCutClick(Sender: TObject);
    procedure mnuEditCopyClick(Sender: TObject);
    procedure mnuEditPasteClick(Sender: TObject);
    procedure mnuHelpSymbolsClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuFilePrintClick(Sender: TObject);
    procedure mnuFileNextClick(Sender: TObject);
    procedure cmdNextNotifClick(Sender: TObject);
    procedure stsAreaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure stsAreaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure stsAreaDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
      const Rect: TRect);
    procedure pnlPrimaryCareMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure pnlPrimaryCareMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    function FormHelp(Command: Word; Data: Integer;
      var CallHelp: Boolean): Boolean;
    procedure mnuViewRemindersClick(Sender: TObject);
    procedure pnlRemindersMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pnlRemindersMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pnlCIRNClick(Sender: TObject);
    procedure lstCIRNLocationsClick(Sender: TObject);
    procedure popCIRNCloseClick(Sender: TObject);
    procedure popCIRNSelectAllClick(Sender: TObject);
    procedure popCIRNSelectNoneClick(Sender: TObject);
    procedure mnuFilePrintSetupClick(Sender: TObject);
    procedure lstCIRNLocationsChange(Sender: TObject);
    procedure LabInfo1Click(Sender: TObject);
    procedure mnuFileNotifRemoveClick(Sender: TObject);
    procedure mnuToolsOptionsClick(Sender: TObject);
    procedure mnuFileRefreshClick(Sender: TObject);
  private
    FRefreshing: boolean;
    FClosing: boolean;
    FContextChanging: Boolean;
    FChangeSource: Integer;
    FCreateProgress: Integer;
    FEditCtrl: TCustomEdit;
    FLastPage: TfrmPage;
    FNextButtonL: Integer;
    FNextButtonR: Integer;
    FNextButtonActive: Boolean;
    FNextButtonBitmap: TBitmap;
    FTerminate: Boolean;
    FTabChanged: TNotifyEvent;
    FOldActivate: TNotifyEvent;
    procedure AppActivated(Sender: TObject);
    procedure AppException(Sender: TObject; E: Exception);
    function AllowContextChangeAll: Boolean;
    procedure ClearPatient;
    procedure ChangeFont(NewFontSize: Integer);
    //procedure CreateTab(var AnInstance: TObject; AClass: TClass; ATabID: integer; ALabel: string);
    procedure CreateTab(ATabID: integer; ALabel: string);
    function ExpandCommand(x: string): string;
    procedure FitToolbar;
    procedure LoadSizesForUser;
    procedure SaveSizesForUser;
    procedure LoadUserPreferences;
    procedure SaveUserPreferences;
    procedure SwitchToPage(NewForm: TfrmPage);
    function PageIDToTab(PageID: Integer): Integer;
    function TabToPageID(Tab: Integer): Integer;
    function TimeoutCondition: boolean;
    function GetTimedOut: boolean;
    procedure TimeOutAction;
    procedure SetUserTools;
    procedure SetDebugMenu;
    procedure SetupPatient;
    procedure SetUpCIRN;
    procedure RemindersChanged(Sender: TObject);
    procedure ReportsOnlyDisplay;
    procedure UMInitiate(var Message: TMessage);   message UM_INITIATE;
    procedure UMNewOrder(var Message: TMessage);   message UM_NEWORDER;
    procedure UMStatusText(var Message: TMessage); message UM_STATUSTEXT;
    procedure UMShowPage(var Message: TMessage);   message UM_SHOWPAGE;
    procedure WMSetFocus(var Message: TMessage);   message WM_SETFOCUS;
    procedure WMSysCommand(var Message: TMessage); message WM_SYSCOMMAND;
  public
    procedure ShowHideChartTabMenus(AMenuItem: TMenuItem);
    function  TabExists(ATabID: integer): boolean;
    procedure DisplayEncounterText;
    property ChangeSource:    Integer read FChangeSource;
    property ContextChanging: Boolean read FContextChanging;
    property TimedOut:        Boolean read GetTimedOut;
    property Closing:         Boolean read FClosing;
    property OnTabChanged:    TNotifyEvent read FTabChanged write FTabChanged;
  end;

var
  frmFrame: TfrmFrame;
  uTabList: TStringList;
  uRemoteType : string;

implementation

{$R *.DFM}
{$R sBitmaps}
{$R sRemSrch}

uses
  TRPCB, ORNet, rCore, fPtSelMsg, fPtSel, fCover, fProbs, fMeds, fOrders, rOrders, fNotes, fConsults, fDCSumm,
  rMisc, Clipbrd, fLabs, fReports, fPtDemo, fEncnt, fPtCWAD, uCore, fAbout, fReview, fxBroker,
  fxLists, fxServer, ORSystem, fRptBox, fSplash, rODAllergy, uInit, fLabTests, fLabInfo,
  uReminders, fReminderTree, ORClasses, fDeviceSelect, fDrawers, fReminderDialog, ShellAPI, rVitals,
  fOptions, rTemplates, fSurgery, rSurgery, uEventHooks, uSignItems;

const
 //  moved to uConst - RV v16
(*  CT_NOPAGE   = -1;                             // chart tab - none selected
  CT_UNKNOWN  =  0;                             // chart tab - unknown (shouldn't happen)
  CT_COVER    =  1;                             // chart tab - cover sheet
  CT_PROBLEMS =  2;                             // chart tab - problem list
  CT_MEDS     =  3;                             // chart tab - medications screen
  CT_ORDERS   =  4;                             // chart tab - doctor's orders
  CT_HP       =  5;                             // chart tab - history & physical
  CT_NOTES    =  6;                             // chart tab - progress notes
  CT_CONSULTS =  7;                             // chart tab - consults
  CT_DCSUMM   =  8;                             // chart tab - discharge summaries
  CT_LABS     =  9;                             // chart tab - laboratory results
  CT_REPORTS  = 10;                             // chart tab - reports
  CT_SURGERY  = 11;                             // chart tab - surgery*)

  FCP_UPDATE  = 10;                             // form create about to check auto-update
  FCP_SETHOOK = 20;                             // form create about to set timeout hooks
  FCP_SERVER  = 30;                             // form create about to connect to server
  FCP_CHKVER  = 40;                             // form create about to check version
  FCP_OBJECTS = 50;                             // form create about to create core objects
  FCP_FORMS   = 60;                             // form create about to create child forms
  FCP_PTSEL   = 70;                             // form create about to select patient
  FCP_FINISH  = 99;                             // form create finished successfully

  TX_IN_USE     = 'VistA CPRS in use by: ';
  TX_OPTION     = 'OR CPRS GUI CHART';
  TX_PTINQ      = 'Retrieving demographic information...';
  TX_NOTIF_STOP = 'Stop processing notifications?';
  TC_NOTIF_STOP = 'Currently Processing Notifications';
  TX_UNK_NOTIF  = 'Unable to process the follow up action for this notification';
  TC_UNK_NOTIF  = 'Follow Up Action Not Implemented';
  TX_NO_SURG_NOTIF = 'This notification must be processed using the Surgery tab, ' + CRLF +
                     'which is not currently available to you.';
  TC_NO_SURG_NOTIF = 'Surgery Tab Not Available';
  TX_VER1       = 'This is version ';
  TX_VER2       = ' of CPRSChart.exe' + CRLF + 'The server is running version ';
  TX_VER_OLD    = CRLF + 'It is strongly recommended that you upgrade to this version.';
  TX_VER_OLD2   = CRLF + 'The program cannot be run until the client is upgraded.';
  TX_VER_NEW    = CRLF + 'The program cannot be run until the server is upgraded.';
  TC_VER        = 'Server/Client Incompatibility';

  SHOW_NOTIFICATIONS = True;

function TfrmFrame.TimeoutCondition: boolean;
begin
  Result := (FCreateProgress < FCP_PTSEL);
end;

function TfrmFrame.GetTimedOut: boolean;
begin
  Result := uInit.TimedOut;
end;

procedure TfrmFrame.TimeOutAction;
begin
  Close;
end;

{ General Functions and Procedures }

procedure TfrmFrame.AppException(Sender: TObject; E: Exception);
var
  AnAddr: Pointer;
  ErrMsg: string;
begin
  Application.NormalizeTopMosts;
  if (E is EIntError) then
  begin
    ErrMsg := E.Message + CRLF +
              'CreateProgress: ' + IntToStr(FCreateProgress) + CRLF +
              'RPC Info: ' + RPCLastCall;
    if EExternal(E).ExceptionRecord <> nil then
    begin
      AnAddr := EExternal(E).ExceptionRecord^.ExceptionAddress;
      ErrMsg := ErrMsg + CRLF + 'Address was ' + IntToStr(Integer(AnAddr));
    end;
    ShowMessage(ErrMsg);
  end
  else if (E is EBrokerError) then
  begin
    Application.ShowException(E);
    FCreateProgress := FCP_FORMS;
    Close;
  end
  else Application.ShowException(E);
  Application.RestoreTopMosts;
end;

function TfrmFrame.AllowContextChangeAll: Boolean;
begin
  FContextChanging := True;
  Result := frmCover.AllowContextChange;
  if Result then Result := frmProblems.AllowContextChange;
  if Result then Result := frmMeds.AllowContextChange;
  if Result then Result := frmOrders.AllowContextChange;
  if Result then Result := frmNotes.AllowContextChange;
  if Result then Result := frmConsults.AllowContextChange;
  if Result then Result := frmDCSumm.AllowContextChange;
  if Result then
    if Assigned(frmSurgery) then Result := frmSurgery.AllowContextChange;
  if Result then Result := frmLabs.AllowContextChange;
  if Result then Result := frmReports.AllowContextChange;
  if (not User.IsReportsOnly) then
    if (Result and Changes.RequireReview) then Result := ReviewChanges(TimedOut);
  FContextChanging := False;
end;

procedure TfrmFrame.ClearPatient;
{ call all pages to make sure patient related information is cleared (when switching patients) }
begin
  lblPtName.Caption     := '';
  lblPtSSN.Caption      := '';
  lblPtAge.Caption      := '';
  lblPtCWAD.Caption     := '';
  lblPtLocation.Caption := 'Visit Not Selected';
  lblPtProvider.Caption := 'Current Provider Not Selected';
  lblPtCare.Caption     := 'Primary Care Team Unassigned';
  lblPtAttending.Caption := '';
  frmCover.ClearPtData;
  frmProblems.ClearPtData;
  frmMeds.ClearPtData;
  frmOrders.ClearPtData;
  frmNotes.ClearPtData;
  frmConsults.ClearPtData;
  frmDCSumm.ClearPtData;
  if Assigned(frmSurgery) then frmSurgery.ClearPtData;
  frmLabs.ClearPtData;
  frmReports.ClearPtData;
  tabPage.TabIndex := PageIDToTab(CT_NOPAGE);       // to make sure DisplayPage gets called
  ClearReminderData;
  SigItems.Clear;
  lstCIRNLocations.Clear;
  uRemoteType := '';
  HidePatientSelectMessages;
end;

procedure TfrmFrame.DisplayEncounterText;
{ updates the display in the header bar of encounter related information (location & provider) }
begin
  with Encounter do
  begin
    if Length(LocationText) > 0
      then lblPtLocation.Caption := LocationText
      else lblPtLocation.Caption := 'Visit Not Selected';
    if Length(ProviderName) > 0
      then lblPtProvider.Caption := 'Provider:  ' + ProviderName
      else lblPtProvider.Caption := 'Current Provider Not Selected';
  end;
  FitToolBar;
end;

{ Form Events (Create, Destroy) ----------------------------------------------------------- }

procedure TfrmFrame.FormCreate(Sender: TObject);
{ connect to server, create tab pages, select a patient, & initialize core objects }
var
  ClientVer, ServerVer, ServerReq: string;
//  CPRSUpdate :string;
begin
  FTerminate := False;
  AutoUpdateCheck;

  // setup initial timeout here so can timeout logon
  FCreateProgress := FCP_SETHOOK;
  InitTimeOut(TimeoutCondition, TimeOutAction);

  // connect to the server and create an option context
  FCreateProgress := FCP_SERVER;
  if not ConnectToServer(TX_OPTION) then
  begin
    Close;
    Exit;
  end;

  // make sure we're using the matching server version
  FCreateProgress := FCP_CHKVER;
  ClientVer := ClientVersion(Application.ExeName);
  ServerVer := ServerVersion(TX_OPTION, ClientVer);
  ServerReq := Piece(FileVersionValue(Application.ExeName, FILE_VER_INTERNALNAME), ' ', 1);
  if CompareVersion(ServerVer, ServerReq) <> 0 then
  begin
    if CompareVersion(ServerVer, ServerReq) > 0 then                // Server newer than Required
    begin
//      if GetUserParam('ORWOR REQUIRE CURRENT CLIENT') = '1' then
// CHANGED FOR PT. SAFETY RELEASE VERSION 19.16, PATCH OR*3*155 - NEXT LINE COMMENTED OUT:
      if (true) then
      begin
        InfoBox(TX_VER1 + ClientVer + TX_VER2 + ServerVer + TX_VER_OLD2, TC_VER, MB_OK);
        Close;
        Exit;
      end
      else InfoBox(TX_VER1 + ClientVer + TX_VER2 + ServerVer + TX_VER_OLD, TC_VER, MB_OK);
    end;
    if CompareVersion(ServerVer, ServerReq) < 0 then               // Server older then Required
    begin
      InfoBox(TX_VER1 + ClientVer + TX_VER2 + ServerVer + TX_VER_NEW, TC_VER, MB_OK);
      Close;
      Exit;
    end;
  end;
  Application.OnException := AppException;
  FOldActivate := Application.OnActivate;
  Application.OnActivate := AppActivated;
  // create core objects
  FCreateProgress := FCP_OBJECTS;
  User := TUser.Create;

  // Add future tabs here as they are created/implemented:
  if (
     (not User.HasCorTabs) and
     (not User.HasRptTab)
     )
  then
  begin
    InfoBox('No valid tabs assigned', 'Tab Access Problem', MB_OK);
    Close;
    Exit;
  end;
  Patient := TPatient.Create;
  Encounter := TEncounter.Create;
  Changes := TChanges.Create;
  Notifications := TNotifications.Create;
  RemoteSites := TRemoteSiteList.Create;
  RemoteReports := TRemoteReportList.Create;
  uTabList := TStringList.Create;
  // set up structures specific to the user
  Caption := TX_IN_USE + MixedCase(User.Name) + '  (' + RPCBrokerV.Server + ')';
  SetDebugMenu;
  if InteractiveRemindersActive then
    NotifyWhenRemindersChange(RemindersChanged);
  // load all the tab pages
  FCreateProgress := FCP_FORMS;
  //CreateTab(TObject(frmProblems), TfrmProblems, CT_PROBLEMS, 'Problems');
  CreateTab(CT_PROBLEMS, 'Problems');
  CreateTab(CT_MEDS,     'Meds');
  CreateTab(CT_ORDERS,   'Orders');
  CreateTab(CT_NOTES,    'Notes');
  CreateTab(CT_CONSULTS, 'Consults');
  if ShowSurgeryTab then CreateTab(CT_SURGERY,  'Surgery');
  CreateTab(CT_DCSUMM,   'D/C Summ');
  CreateTab(CT_LABS,     'Labs');
  CreateTab(CT_REPORTS,  'Reports');
  CreateTab(CT_COVER,    'Cover Sheet');
  ShowHideChartTabMenus(mnuViewChart);
  LoadUserPreferences;
  FNextButtonBitmap := TBitmap.Create;
  FNextButtonBitmap.LoadFromResourceName(hInstance, 'BMP_HANDRIGHT');
  // set the timeout to DTIME now that there is a connection
  UpdateTimeOutInterval(User.DTIME * 1000);  // DTIME * 1000 mSec
  // get a patient
  HandleNeeded;                              // make sure handle is there for ORWPT SHARE call
  FCreateProgress := FCP_PTSEL;
  PostMessage(Handle, UM_INITIATE, 0, 0);    // select patient after main form is created
//  mnuFileOpenClick(Self);
//  if Patient.DFN = '' then  //*DFN*
//  begin
//    Close;
//    Exit;
//  end;
//  if WindowState = wsMinimized then WindowState := wsNormal;
  FCreateProgress := FCP_FINISH;
  pnlReminders.Visible := InteractiveRemindersActive;
  Enabled := False;
  uRemoteType := '';
  SetUserTools;
  if User.IsReportsOnly then // Reports Only tab.
    ReportsOnlyDisplay; // Calls procedure to hide all components/menus not needed.
end;

procedure TfrmFrame.UMInitiate(var Message: TMessage);
begin
  NotifyOtherApps(NAE_OPEN, IntToStr(User.DUZ));
  mnuFileOpenClick(Self);
  Enabled := True;
  // If TimedOut, Close has already been called.
  if not TimedOut and (Patient.DFN = '') then Close;
end;

procedure TfrmFrame.FormDestroy(Sender: TObject);
{ free core objects used by CPRS }
begin
  Application.OnActivate := FOldActivate;
  FNextButtonBitmap.Free;
  uTabList.Free;
  RemoteSites.Free;
  RemoteReports.Free;
  Notifications.Free;
  Changes.Free;
  Encounter.Free;
  Patient.Free;
  User.Free;
end;

procedure TfrmFrame.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
{ cancels close if the user cancels the ReviewChanges screen }
begin
  if (FCreateProgress < FCP_FINISH) then Exit;
  if User.IsReportsOnly then // Reports Only tab.
    exit;
  if TimedOut then
    begin
      if Changes.RequireReview then ReviewChanges(TimedOut);
      Exit;
    end;
  if not AllowContextChangeAll then CanClose := False;
end;

procedure TfrmFrame.SetUserTools;
var
  ToolItems: TToolItemList;
  i: Integer;
  UserTool: TMenuItem;
  OptionsClick: TNotifyEvent;
begin
  if User.IsReportsOnly then // Reports Only tab.
  begin
    mnuTools.Clear; // Remove all current items.
    UserTool := TMenuItem.Create(Self);
    UserTool.Caption := 'Options...';
    UserTool.Hint := 'Options';
    UserTool.OnClick := mnuToolsOptionsClick;
    mnuTools.Add(UserTool); // Add back the "Options" menu.
    exit;
  end;
  GetToolMenu(ToolItems); // For all other users, proceed normally with creation of Tools menu:
  for i := 0 to 30 do with ToolItems[i] do if Length(Caption) > 0 then
  begin
    UserTool := TMenuItem.Create(Self);
    UserTool.Caption := Caption;
    UserTool.Hint := Action;
    UserTool.OnClick := ToolClick;
    mnuTools.Insert(i, UserTool);
  end;
end;

procedure TfrmFrame.FormClose(Sender: TObject; var Action: TCloseAction);
//var
//  i: Integer;
//  UserTool: TMenuItem;
begin
  FClosing := TRUE;
  if FCreateProgress < FCP_FINISH then FTerminate := True;
  if FCreateProgress = FCP_FINISH then NotifyOtherApps(NAE_CLOSE, '');
  // unhook the timeout hooks
  ShutDownTimeOut;
  // clearing changes will unlock notes
  if FCreateProgress = FCP_FINISH then Changes.Clear;
  // save user preferences
  if FCreateProgress = FCP_FINISH then SaveUserPreferences;
  // call close for each page in case there is any special processing
  if FCreateProgress > FCP_FORMS then
  begin
    mnuFrame.Merge(nil);
    frmCover.Close;      //frmCover.Release;
    frmProblems.Close;   //frmProblems.Release;
    frmMeds.Close;       //frmMeds.Release;
    frmOrders.Close;     //frmOrders.Release;
    frmNotes.Close;      //frmNotes.Release;
    frmConsults.Close;   //frmConsults.Release;
    frmDCSumm.Close;     //frmDCSumm.Release;
    if Assigned(frmSurgery) then frmSurgery.Close;    //frmSurgery.Release;
    frmLabs.Close;       //frmLabs.Release;
    frmReports.Close;    //frmReports.Release;
  end;
//  with mnuTools do for i := Count - 1 downto 0 do
//  begin
//    UserTool := Items[i];
//    if UserTool <> nil then
//    begin
//      Delete(i);
//      UserTool.Free;
//    end;
//  end;
  //Application.ProcessMessages;  // so everything finishes closing
  // if < FCP_FINISH we came here from inside FormCreate, so need to call terminate
  if FCreateProgress < FCP_FINISH then Application.Terminate;
end;

procedure TfrmFrame.SetDebugMenu;
var
  IsProgrammer: Boolean;
begin
  IsProgrammer := User.HasKey('XUPROGMODE');
  mnuHelpBroker.Visible  := IsProgrammer;
  mnuHelpLists.Visible   := IsProgrammer;
  mnuHelpSymbols.Visible := IsProgrammer;
  Z6.Visible             := IsProgrammer;
end;

{ Updates posted to MainForm --------------------------------------------------------------- }

procedure TfrmFrame.UMNewOrder(var Message: TMessage);
{ post a notice of change in orders to all TPages, wParam=OrderAction, lParam=TOrder }
var
  OrderAct: string;
begin
  with Message do
  begin
    frmCover.NotifyOrder(WParam, TOrder(LParam));
    frmProblems.NotifyOrder(WParam, TOrder(LParam));
    frmMeds.NotifyOrder(WParam, TOrder(LParam));
    frmOrders.NotifyOrder(WParam, TOrder(LParam));
    frmNotes.NotifyOrder(WParam, TOrder(LParam));
    frmConsults.NotifyOrder(WParam, TOrder(LParam));
    frmDCSumm.NotifyOrder(WParam, TOrder(LParam));
    if Assigned(frmSurgery) then frmSurgery.NotifyOrder(WParam, TOrder(LParam));
    frmLabs.NotifyOrder(WParam, TOrder(LParam));
    frmReports.NotifyOrder(WParam, TOrder(LParam));
    lblPtCWAD.Caption := GetCWADInfo(Patient.DFN);
    if Length(lblPtCWAD.Caption) > 0
      then lblPtPostings.Caption := 'Postings'
      else lblPtPostings.Caption := 'No Postings';
    OrderAct := '';
    case WParam of
    ORDER_NEW:   OrderAct := 'NW';
    ORDER_DC:    OrderAct := 'DC';
    ORDER_RENEW: OrderAct := 'RN';
    ORDER_HOLD:  OrderAct := 'HD';
    ORDER_EDIT:  OrderAct := 'XX';
    ORDER_ACT:   OrderAct := 'AC';
    end;
    if Length(OrderAct) > 0 then NotifyOtherApps(NAE_ORDER, OrderAct + U + TOrder(LParam).ID);  // add FillerID
  end;
end;

{ Tab Selection (navigate between pages) --------------------------------------------------- }

procedure TfrmFrame.WMSetFocus(var Message: TMessage);
begin
  if (FLastPage <> nil) and (not TimedOut) and
     (not (csDestroying in FLastPage.ComponentState)) and FLastPage.Visible
    then FLastPage.SetFocus;
end;

procedure TfrmFrame.UMShowPage(var Message: TMessage);
{ shows a page when the UM_SHOWPAGE message is received }
begin
  if FLastPage <> nil then FLastPage.DisplayPage;
  FChangeSource := CC_CLICK;  // reset to click so we're only dealing with exceptions to click
  if assigned(FTabChanged) then
    FTabChanged(Self);
end;

procedure TfrmFrame.SwitchToPage(NewForm: TfrmPage);
{ unmerge/merge menus, bring page to top of z-order, call form-specific OnDisplay code }
begin
  if FLastPage = NewForm then
    begin
      if Notifications.Active then PostMessage(Handle, UM_SHOWPAGE, 0, 0);
      Exit;
    end;
  if (FLastPage <> nil) then mnuFrame.Unmerge(FLastPage.Menu);
  if NewForm <> nil then mnuFrame.Merge(NewForm.Menu);
  lstCIRNLocations.Visible := False;
  pnlCIRN.BevelOuter := bvRaised;
  lstCIRNLocations.SendToBack;
  mnuFilePrint.Enabled := False;           // let individual page enable this
  mnuFilePrintSetup.Enabled := False;      // let individual page enable this
  FLastPage := NewForm;
  if NewForm <> nil then
  begin
    NewForm.BringToFront;                    // to cause tab switch to happen immediately
    NewForm.SetFocus;
    Application.ProcessMessages;
    PostMessage(Handle, UM_SHOWPAGE, 0, 0);  // this calls DisplayPage for the form
  end;
end;

procedure TfrmFrame.mnuChartTabClick(Sender: TObject);
{ use the Tag property of the menu item to switch to proper page }
begin
  with Sender as TMenuItem do tabPage.TabIndex := PageIDToTab(Tag);
end;

procedure TfrmFrame.tabPageChange(Sender: TObject; NewTab: Integer; var AllowChange: Boolean);
{ switches to form linked to NewTab }
begin

  if (not User.IsReportsOnly) then
  begin
    case TabToPageID(NewTab) of
      CT_NOPAGE:   SwitchToPage(nil);
      CT_COVER:    SwitchToPage(frmCover);
      CT_PROBLEMS: SwitchToPage(frmProblems);
      CT_MEDS:     SwitchToPage(frmMeds);
      CT_ORDERS:   SwitchToPage(frmOrders);
      CT_NOTES:    SwitchToPage(frmNotes);
      CT_CONSULTS: SwitchToPage(frmConsults);
      CT_DCSUMM:   SwitchToPage(frmDCSumm);
      CT_SURGERY:  SwitchToPage(frmSurgery);
      CT_LABS:     SwitchToPage(frmLabs);
      CT_REPORTS:  SwitchToPage(frmReports);
    end; {case}
  end
  else // Reports Only tab.
    SwitchToPage(frmReports);

end;

function TfrmFrame.PageIDToTab(PageID: Integer): Integer;
{ returns the tab index that corresponds to a given PageID }
VAR
  i: integer;
begin
  i :=  uTabList.IndexOf(IntToStr(PageID));
  Result := i;
  //Result := uTabList.IndexOf(IntToStr(PageID));
  (*
  Result := -1;
  case PageID of
    CT_NOPAGE:   Result := -1;
    CT_COVER:    Result :=  0;
    CT_PROBLEMS: Result :=  1;
    CT_MEDS:     Result :=  2;
    CT_ORDERS:   Result :=  3;
   {CT_HP:       Result :=  4;}
    CT_NOTES:    Result :=  4;
    CT_CONSULTS: Result :=  5;
    CT_DCSUMM:   Result :=  6;
    CT_LABS:     Result :=  7;
    CT_REPORTS:  Result :=  8;
  end;*)
end;

function TfrmFrame.TabToPageID(Tab: Integer): Integer;
{ returns the constant that identifies the page given a TabIndex }
begin
  if (Tab > -1) and (Tab < uTabList.Count) then
    Result := StrToIntDef(uTabList[Tab], CT_UNKNOWN)
  else
    Result := CT_NOPAGE;
(*  case Tab of
   -1: Result := CT_NOPAGE;
    0: Result := CT_COVER;
    1: Result := CT_PROBLEMS;
    2: Result := CT_MEDS;
    3: Result := CT_ORDERS;
   {4: Result := CT_HP;}
    4: Result := CT_NOTES;
    5: Result := CT_CONSULTS;
    6: Result := CT_DCSUMM;
    7: Result := CT_LABS;
    8: Result := CT_REPORTS;
  end;*)
end;

{ File Menu Events ------------------------------------------------------------------------- }

procedure TfrmFrame.SetupPatient;
var
  AMsg, SelectMsg: string;
  
begin
  with Patient do
  begin
    ClearPatient;  // must be called to avoid leaving previous patient's information visible!
    Visible := True;
    Application.ProcessMessages;
    lblPtName.Caption := Name;
    lblPtSSN.Caption := SSN;
    lblPtAge.Caption := FormatFMDateTime('mmm dd,yyyy', DOB) + ' (' + IntToStr(Age) + ')';
    if Length(CWAD) > 0
      then lblPtPostings.Caption := 'Postings'
      else lblPtPostings.Caption := 'No Postings';
    lblPtCWAD.Caption := CWAD;
    if (Length(PrimaryTeam) > 0) or (Length(PrimaryProvider) > 0)
      then lblPtCare.Caption := PrimaryTeam + ' / ' + MixedCase(PrimaryProvider);
    if Length(Attending) > 0 then lblPtAttending.Caption := 'Attending:  ' + MixedCase(Attending);
    SetUpCIRN;
    DisplayEncounterText;
    SetShareNode(DFN, Handle);
    with Patient do
      NotifyOtherApps(NAE_NEWPT, SSN + U + FloatToStr(DOB) + U + Name);
    SelectMsg := '';
    if MeansTestRequired(Patient.DFN, AMsg) then SelectMsg := AMsg;
    if HasLegacyData(Patient.DFN, AMsg)     then SelectMsg := SelectMsg + CRLF + AMsg;
    ProcessPatientChangeEventHook;
    if Length(SelectMsg) > 0 then ShowPatientSelectMessages(SelectMsg);
  end;
end;

procedure TfrmFrame.mnuFileNextClick(Sender: TObject);
var
  SaveDFN, NewDFN: string;  //*DFN*
  NextIndex: Integer;
begin
  SaveDFN := Patient.DFN;
  Notifications.Next;
  if Notifications.Active then
  begin
    NewDFN := Notifications.DFN;
    //Patient.DFN := Notifications.DFN;
    //if SaveDFN <> Patient.DFN then
    if SaveDFN <> NewDFN then
    begin
      if AllowContextChangeAll then
      begin
        RemindersStarted := FALSE;
        Patient.DFN := NewDFN;
        Encounter.Clear;
        Changes.Clear;
        if Patient.Inpatient then
        begin
          Encounter.Inpatient := True;
          Encounter.Location := Patient.Location;
          Encounter.DateTime := Patient.AdmitTime;
          Encounter.VisitCategory := 'H';
        end;
        if User.IsProvider then Encounter.Provider := User.DUZ;
        SetupPatient;
      end else
      begin
        Patient.DFN := SaveDFN;
        Notifications.Prior;
        Exit;
      end;
    end;
    stsArea.Panels.Items[1].Text := Notifications.Text;
    FChangeSource := CC_NOTIFICATION;
    NextIndex := PageIDToTab(CT_COVER);
    tabPage.TabIndex := CT_NOPAGE;
    mnuFileNotifRemove.Enabled := Notifications.Followup in [NF_FLAGGED_ORDERS,
                                                             NF_ORDER_REQUIRES_ELEC_SIGNATURE,
                                                             NF_MEDICATIONS_EXPIRING,
                                                             NF_UNVERIFIED_MEDICATION_ORDER,
                                                             NF_UNVERIFIED_ORDER,
                                                             NF_FLAGGED_OI_EXP_INPT,
                                                             NF_FLAGGED_OI_EXP_OUTPT];
    case Notifications.FollowUp of
    NF_LAB_RESULTS                   : NextIndex := PageIDToTab(CT_LABS);
    NF_FLAGGED_ORDERS                : NextIndex := PageIDToTab(CT_ORDERS);
    NF_ORDER_REQUIRES_ELEC_SIGNATURE : NextIndex := PageIDToTab(CT_ORDERS);
    NF_ABNORMAL_LAB_RESULTS          : NextIndex := PageIDToTab(CT_LABS);
    NF_IMAGING_RESULTS               : NextIndex := PageIDToTab(CT_REPORTS);
    NF_CONSULT_REQUEST_RESOLUTION    : NextIndex := PageIDToTab(CT_CONSULTS);
    NF_ABNORMAL_IMAGING_RESULTS      : NextIndex := PageIDToTab(CT_REPORTS);
    NF_IMAGING_REQUEST_CANCEL_HELD   : NextIndex := PageIDToTab(CT_ORDERS);
    NF_NEW_SERVICE_CONSULT_REQUEST   : NextIndex := PageIDToTab(CT_CONSULTS);
    NF_CONSULT_REQUEST_CANCEL_HOLD   : NextIndex := PageIDToTab(CT_CONSULTS);
    NF_SITE_FLAGGED_RESULTS          : NextIndex := PageIDToTab(CT_ORDERS);
    NF_ORDERER_FLAGGED_RESULTS       : NextIndex := PageIDToTab(CT_ORDERS);
    NF_ORDER_REQUIRES_COSIGNATURE    : NextIndex := PageIDToTab(CT_ORDERS);
    NF_LAB_ORDER_CANCELED            : NextIndex := PageIDToTab(CT_ORDERS);
    NF_STAT_RESULTS                  :
      if Piece(Piece(Notifications.AlertData, '|', 2), '@', 2) = 'LRCH' then
        NextIndex := PageIDToTab(CT_LABS)
      else if Piece(Piece(Notifications.AlertData, '|', 2), '@', 2) = 'GMRC' then
        NextIndex := PageIDToTab(CT_CONSULTS)
      else if Piece(Piece(Notifications.AlertData, '|', 2), '@', 2) = 'RA' then
        NextIndex := PageIDToTab(CT_REPORTS);
    NF_DNR_EXPIRING                  : NextIndex := PageIDToTab(CT_ORDERS);
    NF_MEDICATIONS_EXPIRING          : NextIndex := PageIDToTab(CT_ORDERS);
    NF_UNVERIFIED_MEDICATION_ORDER   : NextIndex := PageIDToTab(CT_ORDERS);
    NF_NEW_ORDER                     : NextIndex := PageIDToTab(CT_ORDERS);
    NF_IMAGING_RESULTS_AMENDED       : NextIndex := PageIDToTab(CT_REPORTS);
    NF_CRITICAL_LAB_RESULTS          : NextIndex := PageIDToTab(CT_LABS);
    NF_UNVERIFIED_ORDER              : NextIndex := PageIDToTab(CT_ORDERS);
    NF_FLAGGED_OI_RESULTS            : NextIndex := PageIDToTab(CT_ORDERS);
    NF_FLAGGED_OI_ORDER              : NextIndex := PageIDToTab(CT_ORDERS);
    NF_DC_ORDER                      : NextIndex := PageIDToTab(CT_ORDERS);
    NF_CONSULT_UNSIGNED_NOTE         : NextIndex := PageIDToTab(CT_CONSULTS);
    NF_DCSUMM_UNSIGNED_NOTE          : NextIndex := PageIDToTab(CT_DCSUMM);
    NF_NOTES_UNSIGNED_NOTE           : NextIndex := PageIDToTab(CT_NOTES);
    NF_CONSULT_REQUEST_UPDATED       : NextIndex := PageIDToTab(CT_CONSULTS);
    NF_FLAGGED_OI_EXP_INPT           : NextIndex := PageIDToTab(CT_ORDERS);
    NF_FLAGGED_OI_EXP_OUTPT          : NextIndex := PageIDToTab(CT_ORDERS);
    NF_CONSULT_PROC_INTERPRETATION   : NextIndex := PageIDToTab(CT_CONSULTS);
    NF_IMAGING_REQUEST_CHANGED       : NextIndex := PageIDToTab(CT_REPORTS);
    NF_LAB_THRESHOLD_EXCEEDED        : NextIndex := PageIDToTab(CT_LABS);
    NF_SURGERY_UNSIGNED_NOTE         : if TabExists(CT_SURGERY) then
                                         NextIndex := PageIDToTab(CT_SURGERY)
                                       else
                                         InfoBox(TX_NO_SURG_NOTIF, TC_NO_SURG_NOTIF, MB_OK);
                                         //NextIndex := PageIDToTab(CT_NOTES);
    else InfoBox(TX_UNK_NOTIF, TC_UNK_NOTIF, MB_OK);
    end;
    tabPage.TabIndex := NextIndex;
  end
  else mnuFileOpenClick(Self);
end;

procedure TfrmFrame.mnuFileOpenClick(Sender: TObject);
{ select a new patient & update the header displays (patient id, encounter, postings) }
var
  SaveDFN: string;  //*DFN*
  NextTab: Integer;
  ok, OldRemindersStarted: boolean;

begin
  if FRefreshing or User.UseLastTab then
    NextTab := TabToPageID(tabPage.TabIndex)
  else
    NextTab := User.InitialTab;
  if NextTab = CT_NOPAGE then NextTab := User.InitialTab;
  if User.IsReportsOnly then // Reports Only tab.
    NextTab := 0; // Only one tab should exist by this point in "REPORTS ONLY" mode.
  if not TabExists(NextTab) then NextTab := CT_COVER;
  if NextTab = CT_NOPAGE then NextTab := User.InitialTab;
  if not AllowContextChangeAll then Exit;
  // update status text here
  stsArea.Panels.Items[1].Text := '';
  if (not User.IsReportsOnly) then
  begin
    if not FRefreshing then
    begin
      Notifications.Next;   // avoid prompt if no more alerts selected to process  {v14a RV}
      if Notifications.Active then
      begin
        if (InfoBox(TX_NOTIF_STOP, TC_NOTIF_STOP, MB_YESNO) = ID_NO) then
        begin
          Notifications.Prior;
          Exit;
        end;
      end;
      if Notifications.Active then Notifications.Prior;
    end;
  end;
  SaveDFN := Patient.DFN;
  OldRemindersStarted := RemindersStarted;
  RemindersStarted := FALSE;
  try
    if FRefreshing then
      ok := TRUE
    else
    begin
      ok := FALSE;
      if (not User.IsReportsOnly) then
      begin
        SelectPatient(SHOW_NOTIFICATIONS, Font.Size);
        if Notifications.Active then
        begin
          // display 'next notification' button
          //cmdNextNotif.Visible := True;
          FNextButtonActive := True;
          with stsArea.Panels[2] do
          begin
            //Text := 'Next ->';
            Bevel := pbRaised;
          end;
          mnuFileNext.Enabled := True;
          mnuFileNextClick(Self);
        end
        else
        begin
          // hide the 'next notification' button
          //cmdNextNotif.Visible := False;
          FNextButtonActive := False;
          with stsArea.Panels[2] do
          begin
            //Text := '';
            Bevel := pbLowered;
          end;
          mnuFileNext.Enabled := False;
          mnuFileNotifRemove.Enabled := False;
          if Patient.DFN <> SaveDFN then
            ok := TRUE;
        end
      end
      else
      begin
        Notifications.Clear;
        SelectPatient(False, Font.Size); // Call Pt. Sel. w/o notifications.
        ok := TRUE;
      end;
    end;
    if ok then
    begin
      SetupPatient;
      tabPage.TabIndex := PageIDToTab(NextTab);
    end;
  finally
    if (not FRefreshing) and (Patient.DFN = SaveDFN) then
      RemindersStarted := OldRemindersStarted;
  end;
end;

procedure TfrmFrame.mnuFileEncounterClick(Sender: TObject);
{ displays encounter window and updates encounter display in case encounter was updated }
begin
  UpdateEncounter(NPF_ALL); {*KCM*}
  DisplayEncounterText;
end;

procedure TfrmFrame.mnuFileReviewClick(Sender: TObject);
{ displays the Review Changes window (which resets the Encounter object) }
begin
  if Changes.Count > 0 then
  begin
   ReviewChanges(TimedOut);
   if TabToPageID(tabPage.TabIndex)= CT_MEDS then
     frmOrders.InitOrderSheets2;
  end
  else InfoBox('No new changes to review/sign.', 'Review Changes', MB_OK);
end;

procedure TfrmFrame.mnuFileExitClick(Sender: TObject);
{ see the CloseQuery event }
begin
  Close;
end;

{ View Menu Events ------------------------------------------------------------------------- }

procedure TfrmFrame.mnuViewDemoClick(Sender: TObject);
{ displays patient inquiry report (which optionally allows new patient to be selected) }
var
  SelectNew: Boolean;
begin
  StatusText(TX_PTINQ);
  PatientInquiry(SelectNew);
  StatusText('');
  if SelectNew then mnuFileOpenClick(Self);
end;

procedure TfrmFrame.mnuViewPostingsClick(Sender: TObject);
{ displays the window that shows crisis notes, warnings, allergies, & advance directives }
begin
  ShowCWAD;
end;

{ Tool Menu Events ------------------------------------------------------------------------- }

function TfrmFrame.ExpandCommand(x: string): string;
{ look for 'macros' on the command line and expand them using current context }

  procedure Substitute(const Key, Data: string);
  var
    Stop, Start: Integer;
  begin
    Stop  := Pos(Key, x) - 1;
    Start := Stop + Length(Key) + 1;
    x := Copy(x, 1, Stop) + Data + Copy(x, Start, Length(x));
  end;

begin
  if Pos('%MREF', x) > 0 then Substitute('%MREF',
    '^TMP(''ORWCHART'',' + MScalar('$J') + ',''' + DottedIPStr + ''',' + IntToHex(Handle, 8) + ')');
  if Pos('%SRV',  x) > 0 then Substitute('%SRV',  RPCBrokerV.Server);
  if Pos('%PORT', x) > 0 then Substitute('%PORT', IntToStr(RPCBrokerV.ListenerPort));
  if Pos('%DFN',  x) > 0 then Substitute('%DFN',  Patient.DFN);  //*DFN*
  if Pos('%DUZ',  x) > 0 then Substitute('%DUZ',  IntToStr(User.DUZ));
  Result := x;
end;

procedure TfrmFrame.ToolClick(Sender: TObject);
{ executes the program associated with an item on the Tools menu, the command line is stored
  in the item's hint property }
var
  x, AFile, Param: string;
//  StartInfo: TStartupInfo;
//  ProcInfo: TProcessInformation;
begin
  x := ExpandCommand(TMenuItem(Sender).Hint);
  if CharAt(x, 1) = '"' then
  begin
    x     := Copy(x, 2, Length(x));
    AFile := Copy(x, 1, Pos('"',x)-1);
    Param := Copy(x, Pos('"',x)+1, Length(x));
  end else
  begin
    AFile := Piece(x, ' ', 1);
    Param := Copy(x, Length(AFile)+1, Length(x));
  end;
  ShellExecute(Handle, 'open', PChar(AFile), PChar(Param), '', SW_NORMAL);
//  FillChar(StartInfo, SizeOf(StartInfo), 0);
//  StartInfo.CB := SizeOf(StartInfo);
//  CreateProcess(nil, PChar(x), nil, nil, False, DETACHED_PROCESS or NORMAL_PRIORITY_CLASS,
//    nil, nil, StartInfo, ProcInfo);
end;

{ Help Menu Events ------------------------------------------------------------------------- }

procedure TfrmFrame.mnuHelpBrokerClick(Sender: TObject);
{ used for debugging - shows last n broker calls }
begin
  ShowBroker;
end;

procedure TfrmFrame.mnuHelpListsClick(Sender: TObject);
{ used for debugging - shows internal contents of TORListBox }
begin
  if Screen.ActiveControl is TListBox
    then DebugListItems(TListBox(Screen.ActiveControl))
    else InfoBox('Focus control is not a listbox', 'ListBox Data', MB_OK);
end;

procedure TfrmFrame.mnuHelpSymbolsClick(Sender: TObject);
{ used for debugging - shows current symbol table }
begin
  DebugShowServer;
end;

procedure TfrmFrame.mnuHelpAboutClick(Sender: TObject);
{ displays the about screen }
begin
  ShowAbout;
end;

{ Status Bar Methods }

procedure TfrmFrame.UMStatusText(var Message: TMessage);
{ displays status bar text (using the pointer to a text buffer passed in LParam) }
begin
  stsArea.Panels.Items[0].Text := StrPas(PChar(Message.LParam));
  stsArea.Refresh;
end;

procedure TfrmFrame.stsAreaMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (FNextButtonActive) and (X > FNextButtonL) and (X < FNextButtonR)
    then stsArea.Panels[2].Bevel := pbLowered;
end;

procedure TfrmFrame.stsAreaMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if FNextButtonActive then
  begin
    stsArea.Panels[2].Bevel := pbRaised;
    if (X > FNextButtonL) and (X < FNextButtonR) then mnuFileNextClick(Self);
  end;
end;

procedure TfrmFrame.stsAreaDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
  const Rect: TRect);
begin
  if FNextButtonActive then with StatusBar.Canvas do
  begin
    Draw(Rect.Left + 2, Rect.Top, FNextButtonBitmap);	{ draw bitmap }
    TextOut(Rect.Left + 20, Rect.Top + 2, 'Next');	  { draw text to the right of the bitmap }
  end;
end;

{ Toolbar Methods (make panels act like buttons) ------------------------------------------- }

procedure TfrmFrame.pnlPatientMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{ emulate a button press in the patient identification panel }
begin
  pnlPatient.BevelOuter := bvLowered;
  with lblPtName do SetBounds(Left+2, Top+2, Width, Height);
  with lblPtSSN  do SetBounds(Left+2, Top+2, Width, Height);
  with lblPtAge  do SetBounds(Left+2, Top+2, Width, Height);
end;

procedure TfrmFrame.pnlPatientMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{ emulate the button raising in the patient identification panel & call Patient Inquiry }
begin
  pnlPatient.BevelOuter := bvRaised;
  with lblPtName do SetBounds(Left-2, Top-2, Width, Height);
  with lblPtSSN  do SetBounds(Left-2, Top-2, Width, Height);
  with lblPtAge  do SetBounds(Left-2, Top-2, Width, Height);
  mnuViewDemoClick(Self);
end;

procedure TfrmFrame.pnlVisitMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{ emulate a button press in the encounter panel }
begin
  if User.IsReportsOnly then
    exit;
  pnlVisit.BevelOuter := bvLowered;
  //with lblStLocation do SetBounds(Left+2, Top+2, Width, Height);
  with lblPtLocation do SetBounds(Left+2, Top+2, Width, Height);
  with lblPtProvider do SetBounds(Left+2, Top+2, Width, Height);
end;

procedure TfrmFrame.pnlVisitMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{ emulate a button raising in the encounter panel and call Update Provider/Location }
begin
  if User.IsReportsOnly then
    exit;
  pnlVisit.BevelOuter := bvRaised;
  //with lblStLocation do SetBounds(Left-2, Top-2, Width, Height);
  with lblPtLocation do SetBounds(Left-2, Top-2, Width, Height);
  with lblPtProvider do SetBounds(Left-2, Top-2, Width, Height);
  mnuFileEncounterClick(Self);
end;

procedure TfrmFrame.pnlPrimaryCareMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  pnlPrimaryCare.BevelOuter := bvLowered;
  with lblPtCare      do SetBounds(Left+2, Top+2, Width, Height);
  with lblPtAttending do SetBounds(Left+2, Top+2, Width, Height);
end;

procedure TfrmFrame.pnlPrimaryCareMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  pnlPrimaryCare.BevelOuter := bvRaised;
  with lblPtCare      do SetBounds(Left-2, Top-2, Width, Height);
  with lblPtAttending do SetBounds(Left-2, Top-2, Width, Height);
  ReportBox(DetailPrimaryCare(Patient.DFN), 'Primary Care', True);
end;

procedure TfrmFrame.pnlPostingsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ emulate a button press in the postings panel }
begin
  pnlPostings.BevelOuter := bvLowered;
  with lblPtPostings do SetBounds(Left+2, Top+2, Width, Height);
  with lblPtCWAD     do SetBounds(Left+2, Top+2, Width, Height);
end;

procedure TfrmFrame.pnlPostingsMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ emulate a button raising in the posting panel and call Postings }
begin
  pnlPostings.BevelOuter := bvRaised;
  with lblPtPostings do SetBounds(Left-2, Top-2, Width, Height);
  with lblPtCWAD     do SetBounds(Left-2, Top-2, Width, Height);
  mnuViewPostingsClick(Self);
end;

{ Resize and Font-Change procedures -------------------------------------------------------- }

procedure TfrmFrame.LoadSizesForUser;
var
  s1, s2, s3, Dummy: integer;

begin
  SetUserBounds(TControl(frmFrame));
  SetUserWidths(TControl(frmProblems.pnlLeft));
  //SetUserWidths(TControl(frmMeds.pnlLeft));
  SetUserWidths(TControl(frmOrders.pnlLeft));
  SetUserWidths(TControl(frmNotes.pnlLeft));
  SetUserWidths(TControl(frmConsults.pnlLeft));
  SetUserWidths(TControl(frmDCSumm.pnlLeft));
  if Assigned(frmSurgery) then SetUserWidths(TControl(frmSurgery.pnlLeft));
  SetUserWidths(TControl(frmLabs.pnlLeft));
  SetUserWidths(TControl(frmReports.pnlLeft));
  SetUserColumns(TControl(frmOrders.hdrOrders));
  SetUserColumns(TControl(frmMeds.hdrMedsIn));  // still need conversion
  SetUserColumns(TControl(frmMeds.hdrMedsOut));
  SetUserBounds2(ReminderTreeName, RemTreeDlgLeft, RemTreeDlgTop, RemTreeDlgWidth, RemTreeDlgHeight);
  SetUserBounds2(RemDlgName, RemDlgLeft, RemDlgTop, RemDlgWidth, RemDlgHeight);
  SetUserBounds2(RemDlgSplitters, RemDlgSpltr1, RemDlgSpltr2, Dummy ,Dummy);
  SetUserBounds2(DrawerSplitters,s1, s2, s3, Dummy);
  frmNotes.Drawers.LastOpenSize := s1;
  frmConsults.Drawers.LastOpenSize := s2;
  frmDCSumm.Drawers.LastOpenSize := s3;

  if ParamSearch('rez') = '640' then SetBounds(Left, Top, 648, 488);  // for testing
end;

procedure TfrmFrame.SaveSizesForUser;
var
  SizeList: TStringList;
begin
  SizeList := TStringList.Create;
  try
    with SizeList do
    begin
      Add(StrUserBounds(frmFrame));
      Add(StrUserWidth(frmProblems.pnlLeft));
      //Add(StrUserWidth(frmMeds.pnlLeft));
      Add(StrUserWidth(frmOrders.pnlLeft));
      Add(StrUserWidth(frmNotes.pnlLeft));
      Add(StrUserWidth(frmConsults.pnlLeft));
      Add(StrUserWidth(frmDCSumm.pnlLeft));
      if Assigned(frmSurgery) then Add(StrUserWidth(frmSurgery.pnlLeft));
      Add(StrUserWidth(frmLabs.pnlLeft));
      Add(StrUserWidth(frmReports.pnlLeft));
      Add(StrUserColumns(frmOrders.hdrOrders));
      Add(StrUserColumns(frmMeds.hdrMedsIn));
      Add(StrUserColumns(frmMeds.hdrMedsOut));
      Add(StrUserBounds2(ReminderTreeName, RemTreeDlgLeft, RemTreeDlgTop, RemTreeDlgWidth, RemTreeDlgHeight));
      Add(StrUserBounds2(RemDlgName, RemDlgLeft, RemDlgTop, RemDlgWidth, RemDlgHeight));
      Add(StrUserBounds2(RemDlgSplitters, RemDlgSpltr1, RemDlgSpltr2, 0 ,0));
      Add(StrUserBounds2(DrawerSplitters, frmNotes.Drawers.LastOpenSize,
                                             frmConsults.Drawers.LastOpenSize,
                                             frmDCSumm.Drawers.LastOpenSize,0));
    end;
    SaveUserSizes(SizeList);
  finally
    SizeList.Free;
  end;
end;

procedure TfrmFrame.FormResize(Sender: TObject);
{ need to resize tab forms specifically since they don't inherit resize event (because they
  are derived from TForm itself) }
begin
  if FTerminate or FClosing then Exit;
  if csDestroying in ComponentState then Exit;
  MoveWindow(frmCover.Handle,    0, 0, pnlPage.ClientWidth, pnlPage.ClientHeight, True);
  MoveWindow(frmProblems.Handle, 0, 0, pnlPage.ClientWidth, pnlPage.ClientHeight, True);
  MoveWindow(frmMeds.Handle,     0, 0, pnlPage.ClientWidth, pnlPage.ClientHeight, True);
  MoveWindow(frmOrders.Handle,   0, 0, pnlPage.ClientWidth, pnlPage.ClientHeight, True);
  MoveWindow(frmNotes.Handle,    0, 0, pnlPage.ClientWidth, pnlPage.ClientHeight, True);
  MoveWindow(frmConsults.Handle, 0, 0, pnlPage.ClientWidth, pnlPage.ClientHeight, True);
  MoveWindow(frmDCSumm.Handle,   0, 0, pnlPage.ClientWidth, pnlPage.ClientHeight, True);
  if Assigned(frmSurgery) then MoveWindow(frmSurgery.Handle,     0, 0, pnlPage.ClientWidth, pnlPage.ClientHeight, True);
  MoveWindow(frmLabs.Handle,     0, 0, pnlPage.ClientWidth, pnlPage.ClientHeight, True);
  MoveWindow(frmReports.Handle,  0, 0, pnlPage.ClientWidth, pnlPage.ClientHeight, True);
  with stsArea do
  begin
    Panels[1].Width := stsArea.Width - 415;  // Width of other panels in 8pt font is 415
    FNextButtonL := Panels[0].Width + Panels[1].Width;
    FNextButtonR := FNextButtonL + Panels[2].Width;
  end;
  lstCIRNLocations.Left  := FNextButtonL - ScrollBarWidth - 100;
  lstCIRNLocations.Width := ClientWidth - lstCIRNLocations.Left;
  Self.Repaint;
end;

procedure TfrmFrame.ChangeFont(NewFontSize: Integer);
{ Makes changes in all components whenever the font size is changed.  This is hardcoded and
  based on MS Sans Serif for now, as only the font size may be selected. Courier New is used
  wherever non-proportional fonts are required. }
const
  TAB_VOFFSET = 7;
begin
  with Self          do Font.Size := NewFontSize;
  with lblPtName     do Font.Size := NewFontSize;   // must change BOLDED labels by hand
  with lblPtLocation do Font.Size := NewFontSize;
  with lblPtCWAD     do Font.Size := NewFontSize;
  with tabPage       do Font.Size := NewFontSize;
  frmCover.SetFontSize(NewFontSize);                // child pages lack a ParentFont property
  frmProblems.SetFontSize(NewFontSize);
  frmMeds.SetFontSize(NewFontSize);
  frmOrders.SetFontSize(NewFontSize);
  frmNotes.SetFontSize(NewFontSize);
  frmConsults.SetFontSize(NewFontSize);
  frmDCSumm.SetFontSize(NewFontSize);
  if Assigned(frmSurgery) then frmSurgery.SetFontSize(NewFontSize);
  frmLabs.SetFontSize(NewFontSize);
  frmReports.SetFontSize(NewFontSize);
  tabPage.Height := MainFontHeight + TAB_VOFFSET;   // resize tab selector
  FitToolbar;                                       // resize toolbar
end;

procedure TfrmFrame.FitToolBar;
{ resizes and repositions the panels & labels used in the toolbar }
const
  PATIENT_WIDTH = 29;
  VISIT_WIDTH   = 36;
  POSTING_WIDTH = 11.5;
  LINES_HIGH    = 2;
  M_HORIZ       = 4;
  M_MIDDLE      = 2;
  M_NVERT       = 4;
  M_WVERT       = 6;
begin
  pnlToolbar.Height  := (LINES_HIGH * MainFontHeight) + M_HORIZ + M_MIDDLE + M_HORIZ;
  pnlPatient.Width   := HigherOf(PATIENT_WIDTH * MainFontWidth, lblPtName.Width + (M_WVERT * 2));
  lblPtSSN.Top       := M_HORIZ + MainFontHeight + M_MIDDLE;
  lblPtAge.Top       := lblPtSSN.Top;
  lblPtAge.Left      := pnlPatient.Width - lblPtAge.Width - M_WVERT;
  pnlVisit.Width     := HigherOf(LowerOf(VISIT_WIDTH * MainFontWidth,
                                         HigherOf(lblPtProvider.Width + (M_WVERT * 2),
                                                  lblPtLocation.Width + (M_WVERT * 2))),
                                 PATIENT_WIDTH * MainFontWidth);
  lblPtProvider.Top  := lblPtSSN.Top;
  lblPtAttending.Top := lblPtSSN.Top;
  lblCIRNData.Top    := lblPtSSN.Top;
  pnlPostings.Width  := Round(POSTING_WIDTH * MainFontWidth);
  with lblPtPostings do
    SetBounds(M_WVERT, M_HORIZ, pnlPostings.Width-M_WVERT-M_WVERT, MainFontHeight);
  with lblPtCWAD     do
    SetBounds(M_WVERT, lblPtSSN.Top, lblPtPostings.Width, MainFontHeight);
end;

{ Temporary Calls -------------------------------------------------------------------------- }

procedure TfrmFrame.mnuFontSizeClick(Sender: TObject);
begin
  with Sender as TMenuItem do ChangeFont(Tag);
end;

procedure TfrmFrame.mnuEditClick(Sender: TObject);
var
  IsReadOnly: Boolean;
begin
  FEditCtrl := nil;
  if Screen.ActiveControl is TCustomEdit then FEditCtrl := TCustomEdit(Screen.ActiveControl);
  if FEditCtrl <> nil then
  begin
    if      FEditCtrl is TMemo     then IsReadOnly := TMemo(FEditCtrl).ReadOnly
    else if FEditCtrl is TEdit     then IsReadOnly := TEdit(FEditCtrl).ReadOnly
    else if FEditCtrl is TRichEdit then IsReadOnly := TRichEdit(FEditCtrl).ReadOnly
    else IsReadOnly := True;
    mnuEditUndo.Enabled := FEditCtrl.Perform(EM_CANUNDO, 0, 0) <> 0;
    mnuEditCut.Enabled := FEditCtrl.SelLength > 0;
    mnuEditCopy.Enabled := mnuEditCut.Enabled;
    mnuEditPaste.Enabled := (IsReadOnly = False) and Clipboard.HasFormat(CF_TEXT);
  end else
  begin
    mnuEditUndo.Enabled  := False;
    mnuEditCut.Enabled   := False;
    mnuEditCopy.Enabled  := False;
    mnuEditPaste.Enabled := False;
  end;
end;

procedure TfrmFrame.mnuEditUndoClick(Sender: TObject);
begin
  FEditCtrl.Perform(EM_UNDO, 0, 0);
end;

procedure TfrmFrame.mnuEditCutClick(Sender: TObject);
begin
  FEditCtrl.CutToClipboard;
end;

procedure TfrmFrame.mnuEditCopyClick(Sender: TObject);
begin
  FEditCtrl.CopyToClipboard;
end;

procedure TfrmFrame.mnuEditPasteClick(Sender: TObject);
begin
  FEditCtrl.SelText := Clipboard.AsText;
  //FEditCtrl.PasteFromClipboard;  // use AsText to prevent formatting from being pasted
end;

procedure TfrmFrame.mnuFilePrintClick(Sender: TObject);
begin
  case mnuFilePrint.Tag of
  CT_NOTES:    frmNotes.RequestPrint;
  CT_CONSULTS: frmConsults.RequestPrint;
  CT_DCSUMM:   frmDCSumm.RequestPrint;
  CT_REPORTS:  frmReports.RequestPrint;
  CT_LABS:     frmLabs.RequestPrint;
  CT_ORDERS:   frmOrders.RequestPrint;
  CT_PROBLEMS: frmProblems.RequestPrint;
  CT_SURGERY:  if Assigned(frmSurgery) then frmSurgery.RequestPrint;
  end;
end;

procedure TfrmFrame.cmdNextNotifClick(Sender: TObject);
begin
  //mnuFileNextClick(Self);
end;

function TfrmFrame.FormHelp(Command: Word; Data: Integer;
  var CallHelp: Boolean): Boolean;
var
  ActiveForm: TForm;
begin
  inherited;
  if Screen.ActiveForm <> nil then
    begin
      if Screen.ActiveForm.ActiveControl <> nil then
        begin
          if Screen.ActiveForm.ActiveControl is TForm then
            ActiveForm := TForm(Screen.ActiveForm.ActiveControl)
          else if Screen.ActiveForm.ActiveControl.Owner is TForm then
            ActiveForm := TForm(Screen.ActiveForm.ActiveControl.Owner)
          else
            ActiveForm := Screen.ActiveForm;
        end
      else
        ActiveForm := Screen.ActiveForm;
      HelpFile := ActiveForm.HelpFile;
    end ;
  Result := True;
end;

procedure TfrmFrame.WMSysCommand(var Message: TMessage);
begin
  case TabToPageID(tabPage.TabIndex) of
    CT_NOTES:
        if Screen.ActiveControl.Parent.Name = 'cboCosigner' then
          with Message do
            begin
              SendMessage(frmNotes.Handle, Msg, WParam, LParam);
              Result := 0;
            end
        else
          inherited;
    CT_DCSUMM:
        if Screen.ActiveControl.Parent.Name = 'cboAttending' then
          with Message do
            begin
              SendMessage(frmDCSumm.Handle, Msg, WParam, lParam);
              Result := 0;
            end
        else
          inherited;
    CT_CONSULTS:
        if Screen.ActiveControl.Parent.Name = 'cboCosigner' then
          with Message do
            begin
              SendMessage(frmConsults.Handle, Msg, WParam, lParam);
              Result := 0;
            end
        else
          inherited;
  else
    inherited;
  end;
end;

procedure TfrmFrame.mnuViewRemindersClick(Sender: TObject);
begin
  ViewReminderTree;
end;

procedure TfrmFrame.RemindersChanged(Sender: TObject);
var
  ImgName: string;

begin
  pnlReminders.tag := HAVE_REMINDERS;
  pnlReminders.Hint := 'Click to display reminders';
  case GetReminderStatus of
    rsUnknown:       ImgName := 'BMP_REMINDERS_UNKNOWN';
    rsDue:           ImgName := 'BMP_REMINDERS_DUE';
    rsApplicable:    ImgName := 'BMP_REMINDERS_APPLICABLE';
    rsNotApplicable: ImgName := 'BMP_REMINDERS_OTHER';
    else
      begin
        ImgName := 'BMP_REMINDERS_NONE';
        pnlReminders.Hint := 'There are currently no reminders available';
        pnlReminders.tag := NO_REMINDERS;
      end;
  end;
  if(RemindersEvaluatingInBackground) then
  begin
    if(anmtRemSearch.ResName = '') then
    begin
      TORExposedAnimate(anmtRemSearch).OnMouseDown := pnlRemindersMouseDown;
      TORExposedAnimate(anmtRemSearch).OnMouseUp   := pnlRemindersMouseUp;
      anmtRemSearch.ResHandle := 0;
      anmtRemSearch.ResName := 'REMSEARCHAVI';
    end;
    imgReminder.Visible := FALSE;
    anmtRemSearch.Active := TRUE;
    anmtRemSearch.Visible := TRUE;
    if(pnlReminders.Hint <> '') then
      pnlReminders.Hint := CRLF + pnlReminders.Hint + '.';
    pnlReminders.Hint := 'Evaluating Reminders...  ' + pnlReminders.Hint;
  end
  else
  begin
    anmtRemSearch.Visible := FALSE;
    imgReminder.Visible := TRUE;
    imgReminder.Picture.Bitmap.LoadFromResourceName(hInstance, ImgName);
    anmtRemSearch.Active := FALSE;
  end;
  mnuViewReminders.Enabled := (pnlReminders.tag = HAVE_REMINDERS);
end;

procedure TfrmFrame.pnlRemindersMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if(not InitialRemindersLoaded) then
    StartupReminders;
  if(pnlReminders.tag = HAVE_REMINDERS) then
    pnlReminders.BevelOuter := bvLowered;
end;

procedure TfrmFrame.pnlRemindersMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  pnlReminders.BevelOuter := bvRaised;
  if(pnlReminders.tag = HAVE_REMINDERS) then
    mnuViewRemindersClick(Self);
end;

//--------------------- CIRN-related procedures --------------------------------

procedure TfrmFrame.SetUpCIRN;
var
  i: integer;
  ASite: TRemoteSite;
begin
  with RemoteSites do
    begin
      ChangePatient(Patient.DFN);
      if RemoteDataExists and (RemoteSites.Count > 0) then
        begin
          lblCIRN.Enabled     := True;
          lblCIRNData.Enabled := True;
          lblCIRN.Font.Color  := clBlue;
          lblCIRNData.Font.Color  := clBlue;
          pnlCIRN.Hint := 'Click to display other facilities having data for this patient.';
          if RemoteSites.Count > 0 then
            lstCIRNLocations.Items.Add('0' + U + 'All Sites');
          for i := 0 to RemoteSites.Count - 1 do
            begin
              ASite := TRemoteSite(SiteList[i]);
              lstCIRNLocations.Items.Add(ASite.SiteID + U + ASite.SiteName + U +
                FormatFMDateTime('mmm dd yyyy hh:nn', ASite.LastDate));
            end;
        end
      else
        begin
          lblCIRN.Font.Color  := clWindowText;
          lblCIRNData.Font.Color  := clWindowText;
          lblCIRN.Enabled     := False;
          lblCIRNData.Enabled := False;
          pnlCIRN.Hint := NoDataReason;
        end;
    end;
end;

procedure TfrmFrame.pnlCIRNClick(Sender: TObject);
begin
  if not RemoteSites.RemoteDataExists then Exit;
  if (not lstCIRNLocations.Visible) then
    begin
      pnlCIRN.BevelOuter := bvLowered;
      lstCIRNLocations.Visible := True;
      lstCIRNLocations.BringToFront;
      pnlCIRN.Hint := 'Click to close list.';
    end
  else
    begin
      pnlCIRN.BevelOuter := bvRaised;
      lstCIRNLocations.Visible := False;
      lstCIRNLocations.SendToBack;
      pnlCIRN.Hint := 'Click to display other facilities having data for this patient.';
    end
end;

procedure TfrmFrame.lstCIRNLocationsClick(Sender: TObject);
var
  iIndex,j,iAll,iChk: integer;
begin
  iAll := 0;
  iChk := 0;
  if lstCIRNLocations.Items.Count > 0 then
    if piece(lstCIRNLocations.Items[0],'^',1) = '0' then
      iAll := 1;
  iIndex := lstCIRNLocations.ItemIndex;
  with frmReports do
    if piece(uRemoteType,'^',2) = 'V' then
      begin
        lvReports.Items.BeginUpdate;
        lvReports.Items.Clear;
        lvReports.Columns.Clear;
        lvReports.Items.EndUpdate;
      end;
  if piece(lstCIRNLocations.Items[iIndex],'^',1) = '0' then
    begin
      with RemoteSites.SiteList do
        for j := 0 to Count - 1 do
          begin
            if lstCIRNLocations.Checked[iIndex] = true then
              if lstCIRNLocations.Checked[j+1] = false then
                begin
                  lstCIRNLocations.Checked[j+1] := true;
                  TRemoteSite(RemoteSites.SiteList[j]).ReportClear;
                  TRemoteSite(RemoteSites.SiteList[j]).LabClear;
                  frmReports.TabControl1.Tabs.AddObject(TRemoteSite(
                    RemoteSites.SiteList[j]).SiteName,TRemoteSite(Items[j]));
                  frmLabs.TabControl1.Tabs.AddObject(TRemoteSite(
                    RemoteSites.SiteList[j]).SiteName,TRemoteSite(Items[j]));
                end
              else
                begin
                  lstCIRNLocations.Checked[j+1] := false;
                  TRemoteSite(RemoteSites.SiteList[j]).ReportClear;
                  TRemoteSite(RemoteSites.SiteList[j]).LabClear;
                end
            else
              if lstCIRNLocations.Checked[j+1] = true then
                begin
                  lstCIRNLocations.Checked[j+1] := false;
                  TRemoteSite(RemoteSites.SiteList[j]).ReportClear;
                  TRemoteSite(RemoteSites.SiteList[j]).LabClear;
                end;
            lstCIRNLocations.Checked[j+1] := lstCIRNLocations.Checked[iIndex];
            TRemoteSite(RemoteSites.SiteList[j]).Selected :=
              lstCIRNLocations.Checked[j+1];
          end;
      if lstCIRNLocations.Checked[iIndex] = true then
        begin
          with frmReports do
            if piece(uRemoteType,'^',1) = '1' then
              if not(piece(uRemoteType,'^',2) = 'V') then
                begin
                  TabControl1.Visible := true;
                  pnlRightTop.Height := lblTitle.Height + TabControl1.Height;
                end;
          with frmLabs do
            if lstReports.ItemIndex > -1 then
              if piece(lstReports.Items[lstReports.ItemIndex],'^',3) = '1' then
                if not(piece(lstReports.Items[lstReports.ItemIndex],'^',5) = 'V') then
                  TabControl1.Visible := true;
        end;
    end
  else if iIndex > -1 then
    begin
      TRemoteSite(RemoteSites.SiteList[iIndex - iAll]).Selected :=
       lstCIRNLocations.Checked[iIndex];
      if lstCIRNLocations.Checked[iIndex] = true then
        begin
          TRemoteSite(RemoteSites.SiteList[iIndex - iAll]).ReportClear;
          TRemoteSite(RemoteSites.SiteList[iIndex - iAll]).LabClear;
          frmReports.TabControl1.Tabs.AddObject(TRemoteSite(RemoteSites.SiteList
            [iIndex - iAll]).SiteName,TRemoteSite(RemoteSites.SiteList.Items
            [iIndex - iAll]));
          frmLabs.TabControl1.Tabs.AddObject(TRemoteSite(RemoteSites.SiteList
            [iIndex - iAll]).SiteName,TRemoteSite(RemoteSites.SiteList.Items
            [iIndex - iAll]));
          with frmReports do
            if piece(uRemoteType,'^',1) = '1' then
              if not(piece(uRemoteType,'^',2) = 'V') then
                begin
                  TabControl1.Visible := true;
                  pnlRightTop.Height := lblTitle.Height + TabControl1.Height;
                end;
          with frmLabs do
            if lstReports.ItemIndex > -1 then
              if piece(lstReports.Items[lstReports.ItemIndex],'^',3) = '1' then
                if not(piece(lstReports.Items[lstReports.ItemIndex],'^',5) = 'V') then
                  TabControl1.Visible := true;
        end;
    end;
  uReportInstruction := '';
  frmReports.TabControl1.Tabs.Clear;
  frmLabs.TabControl1.Tabs.Clear;
  frmReports.TabControl1.Tabs.AddObject('Local',nil);
  frmLabs.TabControl1.Tabs.AddObject('Local',nil);
  frmLabs.TabControl1.OnChange(nil);
  frmReports.TabControl1.OnChange(nil);
  with RemoteSites.SiteList do
    for j := 0 to Count - 1 do
      if TRemoteSite(Items[j]).Selected then
        begin
          frmReports.TabControl1.Tabs.AddObject(TRemoteSite(Items[j]).SiteName,
            TRemoteSite(Items[j]));
          frmLabs.TabControl1.Tabs.AddObject(TRemoteSite(Items[j]).SiteName,
            TRemoteSite(Items[j]));
          iChk := 1;
        end;
  if iChk = 0 then
    begin
      with frmReports do
        begin
          TabControl1.Visible := false;
          pnlRightTop.Height := lblTitle.Height;
        end;
      frmLabs.TabControl1.Visible := false;
    end;
  iChk := 0;
  for j := 1 to lstCIRNLocations.Items.Count - 1 do
    if lstCIRNLocations.Checked[j] = false then
      begin
        iChk := 1;
        break;
      end;
  if iChk = 0 then
    lstCIRNLocations.Checked[0] := true
  else
    lstCIRNLocations.Checked[0] := false;
  {if frmReports.tvReports.Selected <> nil then
    frmReports.tvReportsClick(self);}
end;

procedure TfrmFrame.popCIRNCloseClick(Sender: TObject);
begin
  lstCIRNLocations.Visible := False;
  lstCirnLocations.SendToBack;
  pnlCIRN.BevelOuter := bvRaised;
end;

procedure TfrmFrame.popCIRNSelectAllClick(Sender: TObject);

begin
  lstCIRNLocations.ItemIndex := 0;
  lstCIRNLocations.Checked[0] := true;
  lstCIRNLocations.OnClick(Self);
end;

procedure TfrmFrame.popCIRNSelectNoneClick(Sender: TObject);

begin
  lstCIRNLocations.ItemIndex := 0;
  lstCIRNLocations.Checked[0] := false;
  lstCIRNLocations.OnClick(Self);
end;

procedure TfrmFrame.mnuFilePrintSetupClick(Sender: TObject);
var
  CurrPrt: string;
begin
  CurrPrt := SelectDevice(Self, Encounter.Location, True);
  User.CurrentPrinter := Piece(CurrPrt, U, 1);
end;

procedure TfrmFrame.lstCIRNLocationsChange(Sender: TObject);
begin
  if lstCIRNLocations.ItemIndex > -1 then
    if (lstCIRNLocations.Selected[lstCIRNLocations.ItemIndex] = true) and (uUpdateStat = false) then
      lstCIRNLocations.OnClick(nil);
end;

procedure TfrmFrame.LabInfo1Click(Sender: TObject);
begin
  ExecuteLabInfo;
end;

procedure TfrmFrame.mnuFileNotifRemoveClick(Sender: TObject);
const
  TC_REMOVE_ALERT  = 'Remove Current Alert';
  TX_REMOVE_ALERT1 = 'This action will delete the alert you are currently processing; the alert will ' + CRLF +
        'disappear automatically when all orders have been acted on, but this action may' + CRLF +
        'be used to remove the alert if some orders are to be left unchanged.' + CRLF + CRLF +
        'Your ';
  TX_REMOVE_ALERT2 = ' alert for ';
  TX_REMOVE_ALERT3 = ' will be deleted!' + CRLF + CRLF + 'Are you sure?';
var
  AlertMsg, AlertType: string;

  procedure StopProcessingNotifs;
    begin
      Notifications.Clear;
      FNextButtonActive := False;
      stsArea.Panels[2].Bevel := pbLowered;
      mnuFileNext.Enabled := False;
      mnuFileNotifRemove.Enabled := False;
    end;

begin
  if not Notifications.Active then Exit;
  case Notifications.Followup of
    NF_MEDICATIONS_EXPIRING         : AlertType := 'Expiring Medications';
    NF_ORDER_REQUIRES_ELEC_SIGNATURE: AlertType := 'Unsigned Orders';
    NF_FLAGGED_ORDERS               : AlertType := 'Flagged Orders (for clarification)';
    NF_UNVERIFIED_MEDICATION_ORDER  : AlertType := 'Unverified Medication Order';
    NF_UNVERIFIED_ORDER             : AlertType := 'Unverified Order';
    NF_FLAGGED_OI_EXP_INPT          : AlertType := 'Flagged Orderable Item (INPT)';
    NF_FLAGGED_OI_EXP_OUTPT         : AlertType := 'Flagged Orderable Item (OUTPT)';
  else
    Exit;
  end;
  AlertMsg := TX_REMOVE_ALERT1 + AlertType + TX_REMOVE_ALERT2 + Patient.Name + TX_REMOVE_ALERT3;
  if InfoBox(AlertMsg, TC_REMOVE_ALERT, MB_YESNO) = ID_YES then
    begin
      Notifications.DeleteForCurrentUser;
      Notifications.Next;   // avoid prompt if no more alerts selected to process  {v14a RV}
      if Notifications.Active then
        begin
          if (InfoBox(TX_NOTIF_STOP, TC_NOTIF_STOP, MB_YESNO) = ID_NO) then
            begin
              Notifications.Prior;
              mnuFileNextClick(Self);
            end
          else
            StopProcessingNotifs;
        end
      else
        StopProcessingNotifs;
    end;
end;

procedure TfrmFrame.mnuToolsOptionsClick(Sender: TObject);
// personal preferences - changes may need to be applied to chart
var
  i: integer;
begin
  i := 0;
  DialogOptions(i);
end;

procedure TfrmFrame.LoadUserPreferences;
begin
  LoadSizesForUser;
//  LoadUserVitalPreferences;
  GetUserTemplateDefaults(TRUE);
end;

procedure TfrmFrame.SaveUserPreferences;
begin
  SaveSizesForUser;         // position & size settings
//  SaveUserVitalPreferences; // save Vitals metric setting
  SaveUserTemplateDefaults;
end;

procedure TfrmFrame.mnuFileRefreshClick(Sender: TObject);
begin
  FRefreshing := TRUE;
  try
    mnuFileOpenClick(Self);
  finally
    FRefreshing := FALSE;
  end;
end;

procedure TfrmFrame.AppActivated(Sender: TObject);
begin
  if assigned(FOldActivate) then
    FOldActivate(Sender);
  SetActiveWindow(Application.Handle);
end;

(*procedure TfrmFrame.CreateTab(var AnInstance: TObject; AClass: TClass; ATabID: integer; ALabel: string);
begin
  AnInstance := TPage.Create(Self);
  TPage(AnInstance).Parent := pnlPage;
  TPage(AnInstance).Show;
  uTabList.Add(IntToStr(ATabID));
  tabPage.Tabs.Add(ALabel);
end;*)

procedure TfrmFrame.CreateTab(ATabID: integer; ALabel: string);
begin
  //  old comment - try making owner self (instead of application) to see if solves TMenuItem.Insert bug
  case ATabID of
    CT_PROBLEMS : begin
                    frmProblems := TfrmProblems.Create(Self);
                    frmProblems.Parent := pnlPage;
                    frmProblems.Show;
                  end;
    CT_MEDS     : begin
                    frmMeds := TfrmMeds.Create(Self);
                    frmMeds.Parent := pnlPage;
                    frmMeds.Show;
                  end;
    CT_ORDERS   : begin
                    frmOrders := TfrmOrders.Create(Self);
                    frmOrders.Parent := pnlPage;
                    frmOrders.Show;
                  end;
    CT_HP       : begin
                    // not yet
                  end;
    CT_NOTES    : begin
                    frmNotes := TfrmNotes.Create(Self);
                    frmNotes.Parent := pnlPage;
                    frmNotes.Show;
                  end;
    CT_CONSULTS : begin
                    frmConsults := TfrmConsults.Create(Self);
                    frmConsults.Parent := pnlPage;
                    frmConsults.Show;
                  end;
    CT_DCSUMM   : begin
                    frmDCSumm := TfrmDCSumm.Create(Self);
                    frmDCSumm.Parent := pnlPage;
                    frmDCSumm.Show;
                  end;
    CT_LABS     : begin
                    frmLabs := TfrmLabs.Create(Self);
                    frmLabs.Parent := pnlPage;
                    frmLabs.Show;
                  end;
    CT_REPORTS  : begin
                    frmReports := TfrmReports.Create(Self);
                    frmReports.Parent := pnlPage;
                    frmReports.Show;
                  end;
    CT_SURGERY  : begin
                    frmSurgery := TfrmSurgery.Create(Self);
                    frmSurgery.Parent := pnlPage;
                    frmSurgery.Show;
                  end;
    CT_COVER    : begin
                    frmCover := TfrmCover.Create(Self);
                    frmCover.Parent := pnlPage;
                    frmCover.Show;
                  end;
  else
    Exit;
  end;
  if ATabID = CT_COVER then
    begin
      uTabList.Insert(0, IntToStr(ATabID));
      tabPage.Tabs.Insert(0, ALabel);
    end
  else
    begin
      uTabList.Add(IntToStr(ATabID));
      tabPage.Tabs.Add(ALabel);
    end;
end;

procedure TfrmFrame.ShowHideChartTabMenus(AMenuItem: TMenuItem);
var
  i: integer;
begin
  for i := 0 to AMenuItem.Count - 1 do
    AMenuItem.Items[i].Visible := TabExists(AMenuItem.Items[i].Tag);
end;

function TfrmFrame.TabExists(ATabID: integer): boolean;
begin
  Result := (uTabList.IndexOf(IntToStr(ATabID)) > -1)
end;

procedure TfrmFrame.ReportsOnlyDisplay;
var
  i, tot: integer;
begin

// Pull-down menus:
mnuEdit.visible := false;
mnuView.visible := false;
mnuFileRefresh.visible := false;
mnuFileEncounter.visible := false;
mnuFileReview.visible := false;
mnuFileNext.visible := false;
mnuFileNotifRemove.visible := false;
mnuHelpBroker.visible := false;
mnuHelpLists.visible := false;
mnuHelpSymbols.visible := false;

// Top panel components:
//pnlVisit.visible := false;
pnlVisit.hint := 'Provider/Location';
pnlVisit.onMouseDown := nil;
pnlVisit.onMouseUp := nil;
//pnlPrimaryCare.visible := false;
//pnlPostings.visible := false;
//lblPtCWAD.visible := false;
//lblPtPostings.visible := false;
//pnlReminders.visible := false;
//anmtRemSearch.visible := false;

// Forms for other tabs:
frmCover.visible := false;
frmProblems.visible := false;
frmMeds.visible := false;
frmOrders.visible := false;
frmNotes.visible := false;
frmConsults.visible := false;
frmDCSumm.visible := false;
if Assigned(frmSurgery) then
  frmSurgery.visible := false;
frmLabs.visible := false;

// Other tabs (so to speak):
tabPage.tabs.clear;
tabPage.tabs.add('Reports');

end;

initialization

finalization

end.

