unit fMeds;

{$OPTIMIZATION OFF}                              // REMOVE AFTER UNIT IS DEBUGGED

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  fPage, StdCtrls, Menus, ORCtrls, ORFn, ExtCtrls, ComCtrls, rOrders, uConst;

type
  TfrmMeds = class(TfrmPage)
    mnuMeds: TMainMenu;
    mnuView: TMenuItem;
    mnuViewChart: TMenuItem;
    mnuChartReports: TMenuItem;
    mnuChartLabs: TMenuItem;
    mnuChartDCSumm: TMenuItem;
    mnuChartCslts: TMenuItem;
    mnuChartNotes: TMenuItem;
    mnuChartOrders: TMenuItem;
    mnuChartMeds: TMenuItem;
    mnuChartProbs: TMenuItem;
    mnuChartCover: TMenuItem;
    mnuAct: TMenuItem;
    mnuActNew: TMenuItem;
    Z1: TMenuItem;
    mnuActChange: TMenuItem;
    mnuActDC: TMenuItem;
    mnuActHold: TMenuItem;
    mnuActRenew: TMenuItem;
    Z2: TMenuItem;
    mnuViewActive: TMenuItem;
    mnuViewExpiring: TMenuItem;
    Z3: TMenuItem;
    mnuViewSortClass: TMenuItem;
    mnuViewSortName: TMenuItem;
    Z4: TMenuItem;
    mnuViewDetail: TMenuItem;
    sptVert: TSplitter;
    popMed: TPopupMenu;
    popMedDetails: TMenuItem;
    N1: TMenuItem;
    popMedChange: TMenuItem;
    popMedDC: TMenuItem;
    popMedRenew: TMenuItem;
    N2: TMenuItem;
    popMedNew: TMenuItem;
    mnuActCopy: TMenuItem;
    mnuActRefill: TMenuItem;
    mnuActTransfer: TMenuItem;
    popMedRefill: TMenuItem;
    pnlMedIn: TPanel;
    lstMedsIn: TListBox;
    hdrMedsIn: THeaderControl;
    pnlMedOut: TPanel;
    hdrMedsOut: THeaderControl;
    lstMedsOut: TListBox;
    mnuChartSurgery: TMenuItem;
    mnuViewHistory: TMenuItem;
    popMedHistory: TMenuItem;
    procedure mnuChartTabClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lstMedsMeasureItem(Control: TWinControl; Index: Integer;
      var AHeight: Integer);
    procedure lstMedsDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure mnuViewDetailClick(Sender: TObject);
    procedure lstMedsExit(Sender: TObject);
    procedure lstMedsDblClick(Sender: TObject);
    procedure lstMedsInClick(Sender: TObject);
    procedure lstMedsOutClick(Sender: TObject);
    procedure hdrMedsOutSectionResize(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure hdrMedsInSectionResize(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure mnuActDCClick(Sender: TObject);
    procedure mnuActHoldClick(Sender: TObject);
    procedure mnuActRenewClick(Sender: TObject);
    procedure mnuActChangeClick(Sender: TObject);
    procedure mnuActCopyClick(Sender: TObject);
    procedure mnuActNewClick(Sender: TObject);
    procedure mnuActRefillClick(Sender: TObject);
    procedure mnuActClick(Sender: TObject);
    procedure pnlMedOutResize(Sender: TObject);
    procedure mnuViewHistoryClick(Sender: TObject);
  private
    FIterating: Boolean;
    procedure RefreshMedLists;
    function ListSelected(const ErrMsg: string): TListBox;
    procedure ValidateSelected(AListBox: TListBox; const AnAction, WarningMsg, WarningTitle: string);
    procedure MakeSelectedList(AListBox: TListBox; AList: TList);
    procedure SynchListToOrders(AListBox: TListBox; AList: TList);
  public
    procedure ClearPtData; override;
    procedure DisplayPage; override;
    procedure NotifyOrder(OrderAction: Integer; AnOrder: TOrder); override;
  end;

var
  frmMeds: TfrmMeds;

implementation

uses uCore, fFrame, rMeds, fRptBox, uOrders, fODBase, fOrdersDC, fOrdersHold,
     fOrdersRenew, fOMNavA, fOrdersRefill, fMedCopy, fOrders;

{$R *.DFM}

const
  COL_MEDNAME = 1;
  DG_OUT = 0;
  DG_IN  = 1;
  DG_UD  = 2;
  DG_IV  = 3;
  DG_TPN = 4;
  FMT_INDENT = 12;
  TAG_OUTPT = 1;
  TAG_INPT  = 2;
  TX_NOSEL      = 'No orders are highlighted.  Highlight the orders' + CRLF +
                  'you wish to take action on.';
  TC_NOSEL      = 'No Orders Selected';
  TX_NO_DC      = CRLF + CRLF + '- cannot be discontinued.' + CRLF + CRLF + 'Reason: ';
  TC_NO_DC      = 'Unable to Discontinue';
  TX_NO_RENEW   = CRLF + CRLF + '- cannot be changed.' + CRLF + CRLF + 'Reason: ';
  TC_NO_RENEW   = 'Unable to Renew Order';
  TX_NO_HOLD    = CRLF + CRLF + '- cannot be placed on hold.' + CRLF + CRLF + 'Reason:  ';
  TC_NO_HOLD    = 'Unable to Hold';
  TX_NO_COPY    = CRLF + CRLF + '- cannot be copied.' + CRLF + CRLF + 'Reason: ';
  TC_NO_COPY    = 'Unable to Copy Order';
  TX_NO_CHANGE  = CRLF + CRLF + '- cannot be changed.' + CRLF + CRLF + 'Reason: ';
  TC_NO_CHANGE  = 'Unable to Change Order';
  TX_NO_REFILL  = CRLF + CRLF + '- cannot be refilled.' + CRLF + CRLF + 'Reason: ';
  TC_NO_REFILL  = 'Unable to Refill Order';

var
  uMedListIn, uMedListOut: TList;
  uPendingChanges: TStringList;
  uDGrp: array[0..4] of Integer;

{ TPage common methods --------------------------------------------------------------------- }

procedure TfrmMeds.ClearPtData;
begin
  inherited ClearPtData;
  lstMedsIn.Clear;
  lstMedsOut.Clear;
  ClearMedList(uMedListIn);
  ClearMedList(uMedListOut);
  uPendingChanges.Clear;
end;

procedure TfrmMeds.DisplayPage;
const
  RATIO_SMALL = 0.13; //0.1866;
var
  SmallHt, ExtraHt: Integer;
begin
  inherited DisplayPage;
  frmFrame.ShowHideChartTabMenus(mnuViewChart);
  if InitPage and User.NoOrdering then
  begin
    mnuAct.Enabled       := False;
    popMedChange.Enabled := False;
    popMedDC.Enabled     := False;
    popMedRenew.Enabled  := False;
    popMedNew.Enabled    := False;
  end;
  if InitPage and User.DisableHold then mnuActHold.Visible := False;
  if InitPatient then
  begin
    ExtraHt := sptVert.Height + shpPageBottom.Height;
    SmallHt := Round(RATIO_SMALL * (ClientHeight - ExtraHt));
    if Patient.Inpatient
      then pnlMedOut.Height := SmallHt
      else pnlMedOut.Height := ClientHeight - SmallHt - ExtraHt;
    RefreshMedLists;
  end;
end;

procedure TfrmMeds.mnuChartTabClick(Sender: TObject);
begin
  inherited;
  frmFrame.mnuChartTabClick(Sender);
end;

procedure TfrmMeds.NotifyOrder(OrderAction: Integer; AnOrder: TOrder);
var
  AMedList: TList;
  AListBox: TListBox;
  NewMedRec: TMedListRec;
  i, Match: Integer;

  procedure SetCurrentOrderID;
  var
    i: Integer;
    AMedRec: TMedListRec;
  begin
    with AMedList do for i := 0 to Count - 1 do
    begin
      AMedRec := TMedListRec(AMedList[i]);
      if Piece(AMedRec.OrderID, ';', 1) = Piece(AnOrder.ActionOn, ';', 1) then
      begin
      end;
    end;
  end;

  function IndexForCurrentID(const AnID: string): Integer;
  var
    i: Integer;
  begin
    Result := -1;
    for i := 0 to uPendingChanges.Count - 1 do
      if Piece(uPendingChanges[i], U, 2) = AnID then Result := i;
    if Result < 0 then
      for i := 0 to uPendingChanges.Count - 1 do
        if Piece(uPendingChanges[i], '=', 1) = Piece(AnID, ';', 1) then Result := i;
  end;

begin
  AMedList := nil;
  if AnOrder <> nil then
  begin
    if uDGrp[DG_OUT] = AnOrder.DGroup then AMedList := uMedListOut;
    for i := 1 to 4 do if uDGrp[i] = AnOrder.DGroup then AMedList := uMedListIn;
  end;
  case OrderAction of
  ORDER_NEW:  { sent by accept order on new order }
    if AMedList <> nil then
    begin
      // check this out carefully!!
      NewMedRec := TMedListRec.Create;
      NewMedRec.OrderID := AnOrder.ID;
      NewMedRec.Instruct := AnOrder.Text;
      NewMedRec.Inpatient := AMedList = uMedListIn;
      AMedList.Insert(0, NewMedRec);
      if AMedList = uMedListIn
        then lstMedsIn.Items.Insert(0, U + AnOrder.ID)
        else lstMedsOut.Items.Insert(0, U + AnOrder.ID);
      uPendingChanges.Add(Piece(AnOrder.ID, ';', 1) + '=NW^' + AnOrder.ID);
    end;
  ORDER_DC:   { sent by a diet to cancel a tubefeeding - do nothing };
  ORDER_EDIT: { sent by accept on edit order }
    if AMedList <> nil then
    begin
      Match := IndexForCurrentID(AnOrder.EditOf);
      if Match < 0
        { add a new pending change if there is no existing change that matches EditOf }
        then uPendingChanges.Add(Piece(AnOrder.EditOf, ';', 1) + '=XX' + U + AnOrder.ID + U + AnOrder.Text)
        { leave 1st piece (original ID) intact, while changing text & current ID }
        else uPendingChanges[Match] := Piece(uPendingChanges[Match], '=', 1) + '=XX' + U + AnOrder.ID + U + AnOrder.Text;
    end;
  ORDER_ACT:  { sent by DC, Hold, & Renew actions }
    if AMedList <> nil then
    begin
      if Piece(AnOrder.ActionOn, '=', 2) = 'CA' then
      begin
        // cancel action, remove from PendingChanges
        Match := IndexForCurrentID(Piece(AnOrder.ActionOn, '=', 1));
        if Match > -1 then uPendingChanges.Delete(Match);
      end
      else if Piece(AnOrder.ActionOn, '=', 2) = 'DL' then
      begin
        // delete action, show as deleted (set OrderID's to 0 so not confused with next order)
        Match := IndexForCurrentID(Piece(AnOrder.ActionOn, '=', 1));
        if Match > -1 then uPendingChanges[Match] := '0=DL';
        if AMedList = uMedListIn then AListBox := lstMedsIn else AListBox := lstMedsOut;
        with AListBox do for i := 0 to Items.Count - 1 do
          if (U + Piece(AnOrder.ActionOn, '=', 1)) = Items[i] then Items[i] := '^0';
        Match := -1;
        with AMedList do for i := 0 to Count - 1 do
          if TMedListRec(Items[i]).OrderID = Piece(AnOrder.ActionOn, '=', 1) then Match := i;
        if Match > -1 then TMedListRec(AMedList.Items[Match]).OrderID := '0';
      end
      else uPendingChanges.Add(Piece(AnOrder.ActionOn, ';', 1) + '=' +
                               Piece(AnOrder.ActionOn, '=', 2) + U + AnOrder.ID);
    end; {if AMedList}
  ORDER_SIGN: { sent by fReview, fOrderSign when orders signed, AnOrder=nil}
    begin
      // ** only if tab has been visited?
      uPendingChanges.Clear;
      RefreshMedLists;
    end;
  end; {case}
end;

{ Form events ------------------------------------------------------------------------------ }

procedure TfrmMeds.FormCreate(Sender: TObject);
begin
  inherited;
  lstMedsIn.Color := ReadOnlyColor;
  lstMedsOut.Color := ReadOnlyColor;
  uMedListIn  := TList.Create;
  uMedListOut := TList.Create;
  uPendingChanges := TStringList.Create;
  uDGrp[DG_OUT] := DGroupIEN('O RX');
  uDGrp[DG_IN]  := DGroupIEN('I RX');
  uDGrp[DG_UD]  := DGroupIEN('UD RX');
  uDGrp[DG_IV]  := DGroupIEN('IV RX');
  uDGrp[DG_TPN] := DGroupIEN('TPN');
end;

procedure TfrmMeds.FormDestroy(Sender: TObject);
begin
  inherited;
  ClearMedList(uMedListIn);
  ClearMedList(uMedListOut);
  uMedListIn.Free;
  uMedListOut.Free;
  uPendingChanges.Free;
end;

{ View menu events ------------------------------------------------------------------------- }

procedure TfrmMeds.mnuViewDetailClick(Sender: TObject);
var
  AnID, ATitle, AnOrder: string;
  AListBox: TListBox;
  i,j,idx: Integer;
  tmpList: TStringList;
begin
  inherited;
  tmpList := TStringList.Create;
  try
    idx := 0;
    AListBox := ListSelected(TX_NOSEL);
    if AListBox = nil then Exit
    else if AListBox = lstMedsOut then ATitle := 'Outpatient Medication Details'
    else ATitle := 'Inpatient Medication Details';
    FIterating := True;
    with AListBox do for i := 0 to Items.Count - 1 do if Selected[i] then
    begin
      AnID := Piece(Items[i], U, 1);
      if AnID <> '' then
        begin
          tmpList.Assign(DetailMedLM(AnID));
        end;
      AnOrder := Piece(Items[i], U, 2);
      if AnOrder <> '' then
        begin
          tmpList.Add('');
          tmpList.Add(StringOfChar('=', 74));
          tmpList.Add('');
          tmpList.AddStrings(MedAdminHistory(AnOrder));
        end;
      if CheckOrderGroup(AnOrder)=1 then  // if it's UD group
      begin
        for j := 0 to tmpList.Count - 1 do
        begin
          if Pos('PICK UP',UpperCase(tmpList[j]))>0 then
          begin
            idx := j;
            Break;
          end;
        end;
        if idx > 0 then
          tmpList.Delete(idx);
      end;
      if tmpList.Count > 0 then ReportBox(tmpList, ATitle, True);
    end;
    FIterating := False;
    ResetSelectedForList(AListBox);
  finally
    tmpList.Free;
  end;
end;

procedure TfrmMeds.mnuViewHistoryClick(Sender: TObject);
var
  ATitle, AnOrder: string;
  AListBox: TListBox;
  i: Integer;
begin
  inherited;
  AListBox := ListSelected(TX_NOSEL);
  if AListBox = nil then Exit
  else if AListBox = lstMedsOut then ATitle := 'Outpatient Medication Administration History'
  else ATitle := 'Inpatient Medication Administration History';
  FIterating := True;
  with AListBox do for i := 0 to Items.Count - 1 do if Selected[i] then
  begin
    AnOrder := Piece(Items[i], U, 2);
    if AnOrder <> '' then
      ReportBox(MedAdminHistory(AnOrder), ATitle, True);
  end;
  FIterating := False;
  ResetSelectedForList(AListBox);
end;

{ Listbox events --------------------------------------------------------------------------- }

procedure TfrmMeds.RefreshMedLists;
var
  i: Integer;
  AMed: TMedListRec;
begin
  lstMedsIn.Clear;
  lstMedsOut.Clear;
  StatusText('Retrieving active medications...');
  LoadActiveMedLists(uMedListIn, uMedListOut);
  with uMedListIn do for i := 0 to Count - 1 do
  begin
    AMed := TMedListRec(Items[i]);
    lstMedsIn.Items.AddObject(AMed.PharmID + U + AMed.OrderID, AMed);
  end;
  with uMedListOut do for i := 0 to Count - 1 do
  begin
    AMed := TMedListRec(Items[i]);
    lstMedsOut.Items.AddObject(AMed.PharmID + U + AMed.OrderID, AMed);
  end;
  StatusText('');
end;

procedure TfrmMeds.lstMedsMeasureItem(Control: TWinControl; Index: Integer;
  var AHeight: Integer);
var
  NewHeight, Indent, RecRight: Integer;
  AMed: TMedListRec;
  AHeader: THeaderControl;
  AMedList: TList;
  ARect: TRect;
  x, y, AnAction: string;
begin
  inherited;
  NewHeight := AHeight;
  case Control.Tag of
  TAG_OUTPT: begin
               AHeader  := hdrMedsOut;
               AMedList := uMedListOut;
             end;
  TAG_INPT:  begin
               AHeader  := hdrMedsIn;
               AMedList := uMedListIn;
             end;
  else       begin
               AHeader := nil;
               AMedList := nil;
             end;
  end;
  with Control as TListBox do if Index < Items.Count then
  begin
    AMed := TMedListRec(AMedList[Index]);  // can't use Items.Objects here - its not there yet
    if AMed <> nil then
    begin
      ARect := ItemRect(Index);
      ARect.Left  := AHeader.Sections[0].Width + 2;
      ARect.Right := ARect.Left + AHeader.Sections[1].Width - 6;
      AnAction := uPendingChanges.Values[Piece(AMed.OrderID, ';', 1)];
      if Length(AnAction) > 0 then Canvas.Font.Style := [fsBold];
      x := AMed.Instruct;
      if CharAt(AnAction, 1) = 'X' then x := Piece(AnAction, U, 3);
      y := '';
      if AMed.IVFluid then Indent := Pos(#10 + 'in ', x) else Indent := Pos(#13, x);
      if Indent > 0 then
      begin
        if AMed.IVFluid then
        begin
          y := Copy(x, Indent + 1, Length(x));
          x := Copy(x, 1, Indent - 1);
        end else
        begin
          y := Copy(x, Indent + 2, Length(x));
          x := Copy(x, 1, Indent - 1);
        end;
      end;
      RecRight := ARect.Right;
      NewHeight := DrawText(Canvas.Handle, PChar(x), Length(x), ARect,
                   DT_CALCRECT or DT_LEFT or DT_NOPREFIX or DT_WORDBREAK) + 2;
      if(length(y)>0) then
      begin
        ARect.Left  := AHeader.Sections[0].Width + FMT_INDENT;
        ARect.Right := RecRight; // Draw Text alters ARect.
        inc(NewHeight,DrawText(Canvas.Handle, PChar(y), Length(y), ARect,
                     DT_CALCRECT or DT_LEFT or DT_NOPREFIX or DT_WORDBREAK) + 2);
      end;
      if NewHeight > 255 then NewHeight := 255;   // windows appears to only look at 8 bits *KCM*
      if NewHeight <  13 then NewHeight := 13;    // show at least one line                 *KCM*
    end; {if AMed}
  end; {if Index}
  AHeight := NewHeight;
end;

procedure TfrmMeds.lstMedsDrawItem(Control: TWinControl; Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
var
  Indent, ReturnHt: Integer;
  x, y, AnAction: string;
  AMed: TMedListRec;
  AMedList: TList;
  AHeader: THeaderControl;
  ARect: TRect;
begin
  inherited;
  case Control.Tag of
  TAG_OUTPT: begin
               AHeader  := hdrMedsOut;
               AMedList := uMedListOut;
             end;
  TAG_INPT:  begin
               AHeader  := hdrMedsIn;
               AMedList := uMedListIn;
             end;
  else       begin
               AHeader := nil;
               AMedList := nil;
             end;
  end;
  ListGridDrawLines(TListBox(Control), AHeader, Index, State);
  with Control as TListBox do if Index < Items.Count then
  begin
    AMed := TMedListRec(AMedList[Index]);  // can't use Items.Objects here - its not there yet
    if AMed <> nil then
    begin
      AnAction := uPendingChanges.Values[Piece(AMed.OrderID, ';', 1)];
      x := '';
      if Length(AnAction) > 0 then
      begin
        Canvas.Font.Style := [fsBold];
        Canvas.Font.Color := clBlue;
        if CharAt(AnAction, 1) = 'X' then x := 'Change'
        else if Piece(AnAction, U, 1) = 'NW' then x := 'New'
        else if Piece(AnAction, U, 1) = 'RN' then x := 'Renew'
        else if Piece(AnAction, U, 1) = 'RF' then x := 'Refill'
        else if Piece(AnAction, U, 1) = 'HD' then x := 'Hold'
        else if Piece(AnAction, U, 1) = 'DL' then x := 'Deleted'
        else if Piece(AnAction, U, 1) = 'DC' then x := 'DC'
        else x := Piece(AnAction, U, 1);
      end;
      ListGridDrawCell(TListBox(Control), AHeader, Index, 0, x, False);
      x := AMed.Instruct;
      // replace pharmacy text with order text if this is a change
      if CharAt(AnAction, 1) = 'X' then x := Piece(AnAction, U, 3);
      y := '';
      if AMed.IVFluid then Indent := Pos(#10 + 'in ', x) else Indent := Pos(#13, x);
      if Indent > 0 then
      begin
        if AMed.IVFluid then
        begin
          y := Copy(x, Indent + 1, Length(x));
          x := Copy(x, 1, Indent - 1);
        end else
        begin
          y := Copy(x, Indent + 2, Length(x));
          x := Copy(x, 1, Indent - 1);
        end;
      end;
      if Length(y) > 0 then
      begin
        ARect := ItemRect(Index);
        ARect.Left  := AHeader.Sections[0].Width + 2;
        ARect.Right := ARect.Left + AHeader.Sections[1].Width - 6;
        ReturnHt  := DrawText(Canvas.Handle, PChar(x), Length(x), ARect, DT_LEFT or DT_NOPREFIX
                      or DT_WORDBREAK);
        ARect.Left  := AHeader.Sections[0].Width + FMT_INDENT;
        ARect.Top   := ARect.Top + ReturnHt;
        DrawText(Canvas.Handle, PChar(y), Length(y), ARect, DT_LEFT or DT_NOPREFIX
                      or DT_WORDBREAK);
      end
      else ListGridDrawCell(TListBox(Control), AHeader, Index, 1, x, True);
      x := FormatFMDateTime('mmm dd,yy', AMed.StopDate);
      ListGridDrawCell(TListBox(Control), AHeader, Index, 2, x, False);
      x := AMed.Status;
      ListGridDrawCell(TListBox(Control), AHeader, Index, 3, x, False);
      if not AMed.Inpatient then
      begin
        x := FormatFMDateTime('mmm dd,yy', AMed.LastFill);
        ListGridDrawCell(TListBox(Control), AHeader, Index, 4, x, False);
        x := AMed.Refills;
        ListGridDrawCell(TListBox(Control), AHeader, Index, 5, x, False);
      end;
    end; {if AMed}
  end; {if Index}
end;

procedure TfrmMeds.lstMedsExit(Sender: TObject);
begin
  inherited;
  if not FIterating then ResetSelectedForList(TListBox(Sender));
end;

procedure TfrmMeds.lstMedsDblClick(Sender: TObject);
begin
  inherited;
  mnuViewDetailClick(Self);
end;

procedure TfrmMeds.lstMedsInClick(Sender: TObject);
var
  i: integer;
begin
  inherited;
  with lstMedsOut do for i := 0 to Items.Count -1 do
    Selected[i] := false;
end;

procedure TfrmMeds.lstMedsOutClick(Sender: TObject);
var
  i: integer;
begin
  inherited;
  with lstMedsIn do for i := 0 to Items.Count -1 do
    Selected[i] := false;
end;

procedure TfrmMeds.hdrMedsOutSectionResize(HeaderControl: THeaderControl;
  Section: THeaderSection);
begin
  inherited;
  RedrawSuspend(Self.Handle);
  with lstMedsOut do
  begin
    IntegralHeight := not IntegralHeight;  // both lines are necessary, this forces the
    IntegralHeight := not IntegralHeight;  // listbox window to be recreated
  end;
  RedrawActivate(Self.Handle);
  lstMedsOut.Invalidate;
  Refresh;
end;

procedure TfrmMeds.hdrMedsInSectionResize(HeaderControl: THeaderControl;
  Section: THeaderSection);
begin
  inherited;
  RedrawSuspend(Self.Handle);
  with lstMedsIn do
  begin
    IntegralHeight := not IntegralHeight;  // both lines are necessary, this forces the
    IntegralHeight := not IntegralHeight;  // listbox window to be recreated
  end;
  RedrawActivate(Self.Handle);
  lstMedsIn.Invalidate;
  Refresh;
end;

{ Action menu events ---------------------------------------------------------------------- }

procedure TfrmMeds.mnuActClick(Sender: TObject);
begin
  inherited;
  if lstMedsOut.SelCount > 0 then
  begin
    mnuActTransfer.Caption := 'Transfer to Inpatient...';
    mnuActTransfer.Enabled := True;
  end
  else if lstMedsIn.SelCount > 0 then
  begin
    mnuActTransfer.Caption := 'Transfer to Outpatient...';
    mnuActTransfer.Enabled := True;
  end
  else
  begin
    mnuActTransfer.Caption := 'Transfer to...';
    mnuActTransfer.Enabled := False;
  end;
end;

procedure TfrmMeds.mnuActDCClick(Sender: TObject);
{ discontinue/cancel/delete the selected med orders as appropriate for each order }
{ similar to action on fOrders}
var
  ActiveList: TListBox;
  SelectedList: TList;
begin
  inherited;
  ActiveList := ListSelected(TX_NOSEL);
  if ActiveList = nil then Exit;
  SelectedList := TList.Create;
  try
    FIterating := True;
    if AuthorizedUser and EncounterPresent and LockedForOrdering then
    begin
      ValidateSelected(ActiveList, OA_DC, TX_NO_DC, TC_NO_DC);
      MakeSelectedList(ActiveList, SelectedList);
      if ExecuteDCOrders(SelectedList) then
      begin
        ResetSelectedForList(ActiveList);
        SynchListToOrders(ActiveList, SelectedList);
      end;
    end;
  finally
    FIterating := False;
    SelectedList.Free;
    UnlockIfAble;
  end;
end;

procedure TfrmMeds.mnuActHoldClick(Sender: TObject);
{ hold the selected med orders as appropriate for each order }
{ similar to action on fOrders}
var
  ActiveList: TListBox;
  SelectedList: TList;
begin
  inherited;
  ActiveList := ListSelected(TX_NOSEL);
  if ActiveList = nil then Exit;
  SelectedList := TList.Create;
  try
    FIterating := True;
    if AuthorizedUser and EncounterPresent and LockedForOrdering then
    begin
      ValidateSelected(ActiveList, OA_HOLD, TX_NO_HOLD, TC_NO_HOLD);
      MakeSelectedList(ActiveList, SelectedList);
      if ExecuteHoldOrders(SelectedList) then
      begin
        AddSelectedToChanges(SelectedList);
        ResetSelectedForList(ActiveList);
        SynchListToOrders(ActiveList, SelectedList);
      end;
    end;
  finally
    FIterating := False;
    SelectedList.Free;
    UnlockIfAble;
  end;
end;

procedure TfrmMeds.mnuActRenewClick(Sender: TObject);
{ renew the selected med orders as appropriate for each order }
{ similar to action on fOrders}
var
  ActiveList: TListBox;
  SelectedList: TList;
begin
  inherited;
  ActiveList := ListSelected(TX_NOSEL);
  if ActiveList = nil then Exit;
  SelectedList := TList.Create;
  try
    FIterating := True;
    if AuthorizedUser and EncounterPresent and LockedForOrdering then
    begin
      ValidateSelected(ActiveList, OA_RENEW, TX_NO_RENEW, TC_NO_RENEW);
      MakeSelectedList(ActiveList, SelectedList);
      if ExecuteRenewOrders(SelectedList) then
      begin
        AddSelectedToChanges(SelectedList);
        ResetSelectedForList(ActiveList);
        SynchListToOrders(ActiveList, SelectedList);
      end;
    end;
  finally
    FIterating := False;
    SelectedList.Free;
    UnlockIfAble;
  end;
end;

procedure TfrmMeds.mnuActChangeClick(Sender: TObject);
{ loop thru selected med orders, present ordering dialog for each with defaults to selected order }
{ similar to action on fOrders}
var
  i: Integer;
  ActiveList: TListBox;
  SelectedList: TList;
  ChangeIFNList: TStringList;
  DelayEvent: TOrderDelayEvent;
begin
  inherited;
  ActiveList := ListSelected(TX_NOSEL);
  if ActiveList = nil then Exit;
  DelayEvent.EventType := 'C';         // temporary, so can pass to ChangeOrders
  DelayEvent.Specialty := 0;
  DelayEvent.Effective := 0;
  SelectedList := TList.Create;        // temporary until able to create ChangeIFNList directly
  ChangeIFNList := TStringList.Create;
  try
    MakeSelectedList(Activelist, SelectedList);
    with SelectedList do for i := 0 to Count - 1 do ChangeIFNList.Add(TOrder(Items[i]).ID);
    if not ShowMsgOn(ChangeIFNList.Count = 0, TX_NOSEL, TC_NOSEL)
      then ChangeOrders(ChangeIFNList, DelayEvent);
    SynchListToOrders(ActiveList, SelectedList);    // rehighlights
  finally
    SelectedList.Free;
    ChangeIFNList.Free;
  end;
end;

procedure TfrmMeds.mnuActCopyClick(Sender: TObject);
{ loop thru selected med orders, present ordering dialog for each with defaults to selected order }
{ similar to action on fOrders}
var
  i: Integer;
  LimitEvent: Char;
  ActiveList: TListBox;
  SelectedList: TList;
  CopyIFNList: TStringList;
  DelayEvent: TOrderDelayEvent;
begin
  inherited;
  ActiveList := ListSelected(TX_NOSEL);
  if ActiveList = nil then Exit;
  if frmOrders.lstSheets.ItemIndex >= 0 then
  begin
    frmOrders.lstSheets.ItemIndex := 0;
    frmOrders.lstSheetsClick(Application);
  end;
  LimitEvent := #0;
  if TComponent(Sender).Name = 'mnuActTransfer' then
  begin
    if ActiveList = lstMedsOut then
      if Patient.Inpatient then LimitEvent := 'C' else LimitEvent := 'A';
    if ActiveList = lstMedsIn  then
      if Patient.Inpatient then LimitEvent := 'D' else LimitEvent := 'C';
  end;
  SelectedList := TList.Create;        // temporary until able to create CopyIFNList directly
  CopyIFNList := TStringList.Create;
  try
    MakeSelectedList(Activelist, SelectedList);
    with SelectedList do for i := 0 to Count - 1 do CopyIFNList.Add(TOrder(Items[i]).ID);
    if not ShowMsgOn(CopyIFNList.Count = 0, TX_NOSEL, TC_NOSEL) then
    begin
      if SetDelayEventForMed(DelayEvent, LimitEvent) then
      begin
        if (Patient.Inpatient) and (DelayEvent.EventType = 'D') then
          TransferOrders(CopyIFNList,DelayEvent)
        else if (not Patient.Inpatient) and (DelayEvent.EventType = 'A') then
         TransferOrders(CopyIFNList,DelayEvent)
        else if (not Patient.Inpatient) and (DelayEvent.EventType = 'T') then
        begin
         TransferOrders(CopyIFNList,DelayEvent);
        end
        else if LimitEvent = #0
          then CopyOrders(CopyIFNList, DelayEvent)
          else TransferOrders(CopyIFNList, DelayEvent);
      end;
    end;
    SynchListToOrders(ActiveList, SelectedList);    // rehighlights
    if XfInToOutNow then
      XfInToOutNow := False;
  finally
    SelectedList.Free;
    CopyIFNList.Free;
  end;
end;

procedure TfrmMeds.mnuActNewClick(Sender: TObject);
{ new med orders dependent on order dialog for inpatient or outpatient }
{ similar to lstWriteClick on fOrders}
var
  DialogInfo: string;
  DelayEvent: TOrderDelayEvent;
begin
  inherited;
  DelayEvent.EventType := 'C';         // temporary, so can pass to CopyOrders
  DelayEvent.Specialty := 0;
  DelayEvent.Effective := 0;
  if not ReadyForNewOrder(DelayEvent) then Exit;
  { get appropriate form, create the dialog form and show it }
  DialogInfo := GetNewDialog;   // DialogInfo = DlgIEN;FormID;DGroup
  case CharAt(Piece(DialogInfo, ';', 4), 1) of
  'A':      ActivateAction(     Piece(DialogInfo, ';', 1),             Self, 0);
  'D', 'Q': ActivateOrderDialog(Piece(DialogInfo, ';', 1), DelayEvent, Self, 0);
  'M':      ActivateOrderMenu(  Piece(DialogInfo, ';', 1), DelayEvent, Self, 0);
  'O':      ActivateOrderSet(   Piece(DialogInfo, ';', 1), DelayEvent, Self, 0);
  else InfoBox('Unsupported dialog type', 'Error', MB_OK);
  end; {case}
end;

procedure TfrmMeds.mnuActRefillClick(Sender: TObject);
{ for selected orders, present refill dialog }
var
  ActiveList: TListBox;
  SelectedList: TList;
begin
  inherited;
  ActiveList := ListSelected(TX_NOSEL);
  if ActiveList = nil then Exit;
  SelectedList := TList.Create;
  try
    FIterating := True;
    if AuthorizedUser and EncounterPresent and LockedForOrdering then
    begin
      ValidateSelected(ActiveList, OA_REFILL, TX_NO_REFILL, TC_NO_REFILL);
      MakeSelectedList(ActiveList, SelectedList);
      if ExecuteRefillOrders(SelectedList) then
      begin
        ResetSelectedForList(ActiveList);
        SynchListToOrders(ActiveList, SelectedList);
      end;
    end;
  finally
    FIterating := False;
    SelectedList.Free;
    UnlockIfAble;
  end;
end;

{ Action utilities --------------------------------------------------------------------------- }

function TfrmMeds.ListSelected(const ErrMsg: string): TListBox;
{ return selected listbox - inpatient or outpatient }
begin
  Result := nil;
  if lstMedsOut.SelCount > 0 then Result := lstMedsOut
  else if lstMedsIn.SelCount > 0 then Result := lstMedsIn;
  if Result = nil then InfoBox(ErrMsg, TC_NOSEL, MB_OK);
end;

procedure TfrmMeds.ValidateSelected(AListBox: TListBox; const AnAction, WarningMsg, WarningTitle: string);
{ loop to validate action on each selected med order, deselect if not valid }
var
  i: Integer;
  OrderText, CurID: string;
  ErrMsg: string;
begin
  with AListBox do for i := 0 to Items.Count - 1 do if Selected[i] then
  begin
    CurID := uPendingChanges.Values[Piece(Piece(Items[i], U, 2), ';', 1)];
    if Length(CurID) > 0
      then CurID := Piece(CurID, U, 2)
      else CurID := Piece(Items[i], U, 2);
    ValidateOrderAction(CurID, AnAction, ErrMsg);
    //ValidateOrderAction(Piece(Items[i], U, 2), AnAction, ErrMsg);
    if Length(ErrMsg) > 0 then
    begin
      OrderText := TextForOrder(Piece(Items[i], U, 2));
      InfoBox(OrderText + WarningMsg + ErrMsg, WarningTitle, MB_OK);
      Selected[i] := False;
    end;
    if Selected[i] and (not OrderIsLocked(CurID, AnAction)) then Selected[i] := False;
  end;
end;

procedure TfrmMeds.MakeSelectedList(AListBox: TListBox; AList: TList);
{ make a list of selected med orders }
var
  i: Integer;
  AnOrder: TOrder;
  CurID: string;
begin
  AList.Clear;
  with AListBox do for i := 0 to Items.Count - 1 do
    if Selected[i] then
    begin
      CurID := uPendingChanges.Values[Piece(Piece(Items[i], U, 2), ';', 1)];
      if Length(CurID) > 0
        then CurID := Piece(CurID, U, 2)
        else CurID := Piece(Items[i], U, 2);
      AnOrder := GetOrderByIFN(CurID);
      //AnOrder := GetOrderByIFN(Piece(Items[i], U, 2));
      AList.Add(AnOrder);
    end;
end;

procedure TfrmMeds.SynchListToOrders(AListBox: TListBox; AList: TList);
{ shows selected med orders as selected }
//var
//  i, j: Integer;
//  AMedListRec: TMedListRec;
//  AnOrder: TOrder;
begin
//  with AListBox do for i := 0 to Items.Count - 1 do
//  begin
//    AMedListRec := TMedListRec(AListBox.Items.Objects[i]);
//    with AList do for j := 0 to Count - 1 do
//    begin
//      AnOrder := TOrder(AList.Items[j]);
//      if Piece(AMedListRec.OrderID, ';', 1) = Piece(AnOrder.ID, ';', 1) then
//      begin
//        //AMedListRec.Instruct := AMedListRec.Instruct + ' * EDITED *';
//        //AMedListRec.Action := MED_NEW;  //*KCM*
//        //AListBox.Selected[i] := True;   // resets valid selections to indicate changes  //*KCM*
//      end;
//    end;
//  end;
  AListBox.Invalidate;
end;

procedure TfrmMeds.pnlMedOutResize(Sender: TObject);
begin
  inherited;
  if pnlMedOut.Height < 20 then pnlMedOut.Height := 20;
end;


end.

