unit fProbs;
{$O-}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  fHSplit, StdCtrls, ExtCtrls, Menus, ORCtrls, Buttons,
  Grids, Vawrgrid, ORfn, uCore, fProbEdt, uConst ;

type
  TfrmProblems = class(TfrmHSplit)
    mnuProbs: TMainMenu;
    mnuView: TMenuItem;
    mnuViewChart: TMenuItem;
    mnuChartCover: TMenuItem;
    mnuChartProbs: TMenuItem;
    mnuChartMeds: TMenuItem;
    mnuChartOrders: TMenuItem;
    mnuChartNotes: TMenuItem;
    mnuChartCslts: TMenuItem;
    mnuChartDCSumm: TMenuItem;
    mnuChartLabs: TMenuItem;
    mnuChartReports: TMenuItem;
    mnuAct: TMenuItem;
    mnuActNew: TMenuItem;
    Z3: TMenuItem;
    mnuActChange: TMenuItem;
    mnuActInactivate: TMenuItem;
    mnuActRemove: TMenuItem;
    mnuActVerify: TMenuItem;
    Z4: TMenuItem;
    mnuActAnnotate: TMenuItem;
    Z1: TMenuItem;
    mnuViewActive: TMenuItem;
    mnuViewBoth: TMenuItem;
    popProb: TPopupMenu;
    popChange: TMenuItem;
    popInactivate: TMenuItem;
    popRestore: TMenuItem;
    popRemove: TMenuItem;
    popVerify: TMenuItem;
    N36: TMenuItem;
    popAnnotate: TMenuItem;
    N37: TMenuItem;
    pnlProbList: TORAutoPanel;
    pnlProbCats: TPanel;
    lblProbCats: TLabel;
    lstCatPick: TORListBox;
    pnlProbEnt: TPanel;
    pnlProbDlg: TPanel;
    wgProbData: TVAWrapGrid;
    mnuViewInactive: TMenuItem;
    mnuViewRemoved: TMenuItem;
    N1: TMenuItem;
    mnuActRestore: TMenuItem;
    mnuViewFilters: TMenuItem;
    N2: TMenuItem;
    lblProbList: TOROffsetLabel;
    pnlView: TPanel;
    N3: TMenuItem;
    popViewDetails: TMenuItem;
    lstView: TORListBox;
    lblView: TOROffsetLabel;
    N4: TMenuItem;
    mnuActDetails: TMenuItem;
    bbNewProb: TORAlignButton;
    lblProbEnt: TLabel;
    mnuViewSave: TMenuItem;
    mnuViewRestoreDefault: TMenuItem;
    mnuViewComments: TMenuItem;
    sptProbPanel: TSplitter;
    pnlButtons: TPanel;
    bbOtherProb: TORAlignButton;
    bbCancel: TORAlignButton;
    pnlProbs: TPanel;
    lblProblems: TLabel;
    lstProbPick: TORListBox;
    edProbEnt: TORAlignEdit;
    mnuChartSurgery: TMenuItem;
    procedure mnuChartTabClick(Sender: TObject);
    procedure lstProbPickClick(Sender: TObject);
    procedure lstProbPickDblClick(Sender: TObject);
    procedure lstCatPickClick(Sender: TObject);
    procedure lstProbActsClick(Sender: TObject);
    procedure pnlProbDlgResize(Sender: TObject);
    procedure pnlRightResize(Sender:TObject); 
    procedure pnlProbEntResize(Sender: TObject);
    procedure wgProbDataClick(Sender: TObject);
    procedure wgProbDataDblClick(Sender: TObject);
    procedure edProbEntKeyPress(Sender: TObject; var Key: Char);
    procedure bbOtherProbClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bbCancelClick(Sender: TObject);
    procedure lstViewClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mnuViewSaveClick(Sender: TObject);
    procedure mnuViewRestoreDefaultClick(Sender: TObject);
    procedure mnuViewCommentsClick(Sender: TObject);
  private
    FContextString: string;
    FFilterString: string;
    procedure UMCloseProblem(var Message:TMessage); message UM_CLOSEPROBLEM; {pdr}
    procedure ApplyViewFilters;
//    procedure UMPLFilter(var Message:TMessage); message UM_PLFILTER; {pdr}
    procedure UMPLLexicon(var Message:TMessage); message UM_PLLEX; {pdr}
    procedure GetRowCount;
  public
    function  AllowContextChange: Boolean; override;
    procedure LoadProblems;
    procedure LoadUserCats(AList:Tstringlist);
    procedure LoadUserProbs(AList:TstringList);
    procedure AddProblem;
    procedure EditProblem(const why:char);
    procedure LoadPatientParams(AList:TstringList);
    procedure LoadUserParams(Alist:TstringList);
    procedure UpdateProblem(const why:char);
    procedure RestoreProblem;
    procedure LoadPatientProblems(AList:TstringList;const status:char;init:boolean);
    procedure ClearPtData; override;
    procedure DisplayPage; override;
    procedure NoRowSelected;
    procedure RowSelected ;
    procedure ClearGrid;
    procedure RequestPrint; override;
  end;

  function EncounterPresent: Boolean;

const
  TX_PROV_LOC   = 'A provider and location must be selected before' +  #13#10 +
                  'entering or making any change to a problem.';
  TC_PROV_LOC   = 'Incomplete Information';
  TX_INVALID_PATIENT = 'Problem list is unavailable:  Patient DFN is undefined.';
  TC_NO_PATIENT      = 'No patient is selected';
  RPT_PROBLIST  = 21;
  CT_PROBLEMS   = 2;

var
  frmProblems: TfrmProblems;
  dlgProbs:TfrmdlgProb;
  gFontHeight: Integer;
  gFontWidth: Integer;
  gFixedWidth: Integer;

implementation

uses fFrame, fProbFlt, fProbLex, uProbs, rProbs, rcover, fCover, fRptBox,
     fProbCmt, fEncnt, fReportsPrint, fReports;

{$R *.DFM}

function TfrmProblems.AllowContextChange: Boolean;
var
  TimeToGo: Boolean;
begin
  TimeToGo := True;
  if dlgProbs <> nil then TimeToGo := dlgProbs.OKToQuit;
  if (dlgProbs <> nil) and TimeToGo then dlgProbs.Close;
  Result := TimeToGo;
  //if dlgProbs <> nil then dlgProbs.bbQuitClick(Self);
end;

procedure TfrmProblems.ClearPtData;
begin
  inherited ClearPtData;
  ClearGrid;
  lblProbList.Caption := '';
end;

procedure TfrmProblems.DisplayPage;
begin
  inherited DisplayPage;
  frmFrame.ShowHideChartTabMenus(mnuViewChart);
  frmFrame.mnuFilePrint.Tag := CT_PROBLEMS;
  frmFrame.mnuFilePrint.Enabled := True;
  frmFrame.mnuFilePrintSetup.Enabled := True;
  if InitPatient then
    begin
      if PLUser <> nil then
        begin
          PLUser.Destroy;
          PLUser := nil;
        end;
      //ClearPtData;
      pnlView.BringToFront ;
      pnlView.Show ;
      pnlButtons.SendToBack;
      pnlButtons.Hide;
      LoadProblems ;
    end;
end;

procedure TfrmProblems.mnuChartTabClick(Sender: TObject);
begin
  inherited;
  frmFrame.mnuChartTabClick(Sender);
end;

{------------------------ pdr - Problem list gadget event methods ------------}
procedure TfrmProblems.lstCatPickClick(Sender: TObject);
var
  AList:TStringList;
begin
  AList:=TStringList.create;
  try
    LoadUserProbs(AList);
  finally
    AList.free;
  end;
end;

procedure TfrmProblems.lstProbActsClick(Sender: TObject);
var
  act, i, j: integer;
  Alist: TstringList;
  cmt, ProblemIFN, ut, x, comments: string ;
  ProbRec: TProbRec ;
  ContextString, FilterString: string;
  FilterChanged: boolean;
begin
  if PLPt = nil then
    begin
      InfoBox(TX_INVALID_PATIENT, TC_NO_PATIENT, MB_OK or MB_ICONWARNING);
      Exit;
    end;
  act := TComponent(Sender).tag ;
  if act = 0 then exit;
   // make sure a visit (time & location) is available before creating the problem
  case act of
    100: {add new problem}
      begin
        if PlUser.usViewAct = 'R' then
          begin
            messagedlg('Cannot add to the "Removed Problem List"',mtInformation,[mbOK],0);
            exit;
          end;
        if not EncounterPresent then exit;
        PLProblem := '';
        AList := TStringList.Create;
        pProviderID := Encounter.Provider;
        pProviderName := Encounter.ProviderName ;
        try
          if pnlView.Visible then
            begin
              pnlView.SendToBack;
              pnlButtons.Visible := True;
              if PLUser.usUseLexicon then
                begin
                  lblProbCats.Visible := True;
                  lstCatPick.Visible  := True;
                  lblProblems.Visible := True;
                  lstProbPick.Visible := True;
                  lstCatPick.Clear ;
                  LoadUserCats(AList);
                  bbOtherProb.Visible := True;
                  pnlProbList.Visible := True ;
                  pnlProbList.BringToFront ;
                  pnlProbCats.ClientHeight := (pnlProbList.ClientHeight - pnlButtons.ClientHeight) div 2;
                  pnlProbEnt.Visible  := False;
                  pnlProbEnt.SendToBack;
                  if (lstCatPick.Items.Count = 1) then
                    if Piece(lstCatPick.Items[0], U, 1) = '-1' then
                      bbOtherProbClick(Self);
                end
              else
                begin
                  bbOtherProb.Visible := False;
                  edProbEnt.Visible := True;
                  lblProbEnt.Visible := True;
                  pnlProbEnt.Visible  := True;
                  pnlProbEnt.BringToFront;
                  pnlProbList.Visible := False ;
                  pnlProbList.SendToBack ;
                  edProbEnt.text      := '';
                  if pnlProbEnt.Visible then edProbEnt.SetFocus;
                end;
            end
          else
            begin
              if (lstProbPick.itemindex < 0) and (edProbEnt.text = '') then
                messagedlg('Select a Problem to add from lists' + #13#10 + ' on left or enter a new one ',
                            mtInformation,[mbOK],0)
              else
                begin
                  AddProblem;
                  lstProbPick.itemindex := -1;
                end;
            end ;
        finally
          AList.Free;
        end;
      end;
    200: {Inactivate}
      begin
        if PlUser.usViewAct = 'R' then
          begin
            messagedlg('Cannot inactivate a problem on the "Removed Problem List"',
                       mtInformation,[mbOK],0);
            exit;
          end;
        if (wgProbData.row < 0) or (wgProbData.cells[2,wgProbData.row] = '') then
          messagedlg('Select a patient problem from the grid on right',mtInformation,[mbOK],0)
        else
          begin
            if not EncounterPresent then exit;
            pProviderID := Encounter.Provider;
            pProviderName := Encounter.ProviderName ;
            UpdateProblem('I');
          end;
      end;
    250: {Verify}
      begin
        if not PLuser.usVerifyTranscribed then exit ;
        if PlUser.usViewAct = 'R' then
          begin
            messagedlg('Cannot verify a problem on the "Removed Problem List"',
                       mtInformation,[mbOK],0);
            exit;
          end;
        if (wgProbData.row < 0) or (wgProbData.cells[2, wgProbData.row] = '') then
          messagedlg('Select a patient problem from the grid on right', mtInformation, [mbOK], 0)
        else if Pos('(u)',wgProbData.cells[1, wgProbData.row]) = 0 then
          messagedlg('Problem selected is already verified', mtInformation, [mbOK], 0)
        else
          begin
            if not EncounterPresent then exit;
            pProviderID := Encounter.Provider;
            pProviderName := Encounter.ProviderName ;
            UpdateProblem('V');
          end;
      end;
    300: {detail}
      with wgProbData do
        begin
          if selection.top<1 then
            messagedlg('Select a problem from the grid for Detail Display', mtInformation,[mbOK],0)
          else if StrToIntDef(cells[0,row],0)>0 then
            ReportBox(DetailProblem(StrToInt(cells[0,row])), Piece(cells[2,row], #13, 1), True);
        end;
    400: {edit}
      begin
        if PlUser.usViewAct = 'R' then
          begin
            messagedlg('Cannot select a problem to edit from the "Removed Problem List"',
                       mtInformation,[mbOK],0);
            exit;
          end;
        if wgProbData.selection.top < 1 then
          messagedlg('Select a problem from the grid to Edit', mtInformation, [mbOK], 0)
        else
          begin
            if not EncounterPresent then exit;
            pProviderID := Encounter.Provider;
            pProviderName := Encounter.ProviderName ;
            EditProblem('E');
          end
      end;
    500: {Remove}
      begin
        if not PlUser.usPrimeUser then exit ;
        if PlUser.usViewAct = 'R' then
          begin
            messagedlg('Cannot remove from the "Removed Problem List"' +#13#10 +
                      'Use "Restore Problem"', mtInformation, [mbOK], 0);
            exit;
          end;
        if wgProbData.selection.top < 1 then
          messagedlg('Select a problem from the grid to remove', mtInformation, [mbOK], 0)
        else
          begin
            if not EncounterPresent then exit;
            pProviderID := Encounter.Provider;
            pProviderName := Encounter.ProviderName ;
            EditProblem('R');
          end;
      end;
    550: {Restore}
      begin
        if not PlUser.usPrimeUser then exit ;
        if PlUser.usViewAct <> 'R' then
          begin
            messagedlg('View the Removed Problems Display, and select a record to restore.',
                       mtInformation, [mbOK], 0);
            exit;
          end;
       if wgProbData.selection.top < 1 then
         messagedlg('Select a problem to restore from the grid on right', mtInformation, [mbOK], 0)
       else
         begin
           if not EncounterPresent then exit;
           pProviderID := Encounter.Provider;
           pProviderName := Encounter.ProviderName ;
           RestoreProblem;
         end;
      end;
    600: {Add Comment}
      begin
        if PlUser.usViewAct = 'R' then
          begin
            messagedlg('Cannot add a comment to a removed problem',mtInformation,[mbOK],0);
            exit;
          end;
        if wgProbData.selection.top < 1 then
          messagedlg('Select a problem to annotate from the grid on right',mtInformation,[mbOK],0)
        else
          begin
            if not EncounterPresent then exit;
            pProviderID := Encounter.Provider;
            pProviderName := Encounter.ProviderName ;
            AList := TStringList.Create;
            ProblemIFN := wgProbData.Cells[0,wgProbData.Row] ;
            AList.Assign(EditLoad(ProblemIFN, pProviderID, PLPt.ptVAMC)) ;
            if Alist.count = 0 then
              begin
                MessageDlg('No Data on Host for problem ' + ProblemIFN,mtInformation,[mbOK],0);
                close;
                exit;
              end;
            ProbRec:=TProbRec.Create(Alist); {create a problem object}
            try
              ProbRec.PIFN := ProblemIFN;
              cmt := NewComment ;
              if (StrToInt(Piece(cmt, U, 1)) > 0) and (Piece(cmt, U, 3) <> '') then
                begin
                  ProbRec.AddNewComment(Piece(cmt, U, 3));
                  ut := '';
                  If PLUser.usPrimeUser then ut := '1';
                  AList.Assign(EditSave(ProblemIFN,pProviderID,PLPt.ptVAMC,ut,ProbRec.FilerObject)) ;
                  LoadPatientProblems(AList,PlUser.usViewAct[1],true);
                end ;
            finally
              Alist.Free ;
              ProbRec.Free ;
            end ;
          end ;
      end;
    700: {Active only}
      begin
        Alist := TstringList.create;
        try
          LoadPatientProblems(Alist,'A',false);
          PlUser.usViewAct := 'A';
          SetPiece(FContextString, ';', 3, 'A');
          GetRowCount;
        finally
          Alist.free;
        end;
      end;
    800: {inactive Only}
      begin
        Alist := TstringList.create;
        try
          LoadPatientProblems(Alist,'I',false);
          PlUser.usViewAct := 'I';
          SetPiece(FContextString, ';', 3, 'I');
          GetRowCount;
        finally
          Alist.free;
        end;
      end;
    900: {all problems display}
      begin
        Alist := TstringList.create;
        try
          LoadPatientProblems(Alist,'B',false);
          PlUser.usViewAct := 'B';
          SetPiece(FContextString, ';', 3, 'B');
          GetRowCount;
        finally
          Alist.free;
        end;
      end;
    950: {Removed Problems Display}
      begin
        Alist := TstringList.create;
        try
          LoadPatientProblems(Alist,'R',false);
          PlUser.usViewAct := 'R';
          SetPiece(FContextString, ';', 3, 'R');
          GetRowCount;
        finally
          Alist.free;
        end;
      end;
    975: {Select viewing filters}
      begin
        lstView.ItemIndex := -1;
        ContextString := '^;;' + PLUser.usViewAct[1] + ';' + PLUser.usViewComments;
        GetViewFilters(Font.Size, PLFilters, ContextString, FilterString, FilterChanged);
        if not FilterChanged then exit;
        FContextString := ContextString;
        FFilterString := FilterString;
        if (Piece(ContextString, ';', 3) <> PLUser.usViewAct[1]) then
          begin
            AList := TStringList.Create;
            try
              PLUser.usViewAct := Piece(ContextString, ';', 3);
              LoadPatientProblems(Alist, PLUser.usViewAct[1], False);
            finally
              AList.Free;
            end;
          end;
        if (Piece(ContextString, ';', 4) <> PLUser.usViewComments) then with wgProbData do
          begin
            for i := 0 to RowCount - 1 do
              begin
                if Objects[2, i] = nil then continue;
                x := Piece(Cells[2, i], #13, 1);
                if Piece(ContextString, ';', 4) = '1' then
                  begin
                    comments := '';
                    for j := 0 to TStringList(Objects[2, i]).Count - 1 do
                      comments := comments + '         ' + TStringList(Objects[2, i]).Strings[j] + #13#10;
                      //comments := comments + '   CMT:  ' + TStringList(Objects[2, i]).Strings[j] + #13#10;
                    cells[2, i] := x + #13#10 + comments;
                    mnuViewComments.Checked := True;
                  end
                else
                  begin
                    cells[2, i] := x;
                    mnuViewComments.Checked := False;
                  end;
              end;
            PLUser.usViewComments := Piece(ContextString, ';', 4);
          end;
        pnlRightResize(Self);
      end ;
  end;
end;

procedure TfrmProblems.lstProbPickClick(Sender: TObject);
begin
  if PlUser.usViewAct = 'R' then exit;
  pProviderID := Encounter.Provider ;
  AddProblem;
  TListBox(sender).itemindex := -1;
end;

procedure TfrmProblems.pnlProbDlgResize(Sender: TObject);
begin
if dlgprobs <> nil then
  with pnlProbDlg do
    dlgprobs.SetBounds(pnlRight.Left + 2, Top + 2, Width - 4, Height - 4);
end;

procedure TfrmProblems.pnlProbEntResize(Sender: TObject);
(*var
  i:integer;*)
begin
(*  for i := 0 to pred(twincontrol(sender).controlcount) do
    begin
      twincontrol(sender).controls[i].width := twincontrol(sender).width - 4;
      twincontrol(sender).controls[i].left := 2;
    end;*)
end;

procedure TfrmProblems.wgProbDataClick(Sender: TObject);
begin
  if wgProbData.rowheights[wgProbData.row] = 0 then exit ;
  pnlRight.font.color := self.font.color;
  pnlRight.caption := Piece(wgProbData.cells[2, wgProbData.row], #13, 1);
  if (wgProbData.cells[0, wgProbData.row] = '') or
     (Pos('No data available',  wgProbData.cells[0, wgProbData.row]) > 0) or
     (Pos('No problems found.', wgProbData.cells[0, wgProbData.row]) > 0)
   then NoRowSelected else RowSelected ;                                               
end;

procedure TfrmProblems.wgProbDataDblClick(Sender: TObject);
begin
  if wgProbData.rowheights[wgProbData.row] = 0 then exit ;
  lstProbActsClick(mnuActDetails);
end;

procedure TfrmProblems.lstProbPickDblClick(Sender: TObject);
begin
  if PlUser.usViewAct = 'R' then exit;
  pProviderID := Encounter.Provider ;
  AddProblem;
  TListBox(sender).itemindex := -1;
end;

procedure TfrmProblems.edProbEntKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then lstProbPickDblClick(sender);
end;

procedure TfrmProblems.bbOtherProbClick(Sender: TObject);
var
  frmPLLex: TfrmPLLex;
begin
  if not PLUser.usUseLexicon then exit; {don't allow lookup}
  frmPLLex := TFrmPLLex.create(Application);
  try
    frmPLLex.showmodal;
  finally
    frmPLLex.Free;
  end;
end;

procedure TfrmProblems.UMCloseProblem(var Message:TMessage);
begin
  pnlView.BringToFront ;
  pnlView.Show ;
  bbCancel.Enabled := True ;
  bbOtherProb.enabled := true; {restore lexicon access}
  pnlButtons.Visible := False;
  pnlButtons.SendToBack;
  pnlProbEnt.Visible :=  (not PLUser.usUseLexicon) ;
  if PLuser.usViewAct = 'A' then
    pnlRight.caption := ACTIVE_LIST_CAP
  else if PLuser.usViewAct = 'I' then
    pnlRight.caption := INACTIVE_LIST_CAP
  else if PLuser.usViewAct = 'B' then
    pnlRight.caption := BOTH_LIST_CAP
  else if PLuser.usViewAct = 'R' then
    pnlRight.caption := REMOVED_LIST_CAP
  else
    begin
      PlUser.usViewAct := 'A';
      pnlRight.caption := ACTIVE_LIST_CAP;
    end;
  if dlgProbs <> nil then dlgProbs:=nil;
end;

//procedure TfrmProblems.UMPLFilter(var Message:TMessage);
procedure TfrmProblems.ApplyViewFilters;
var
  i: integer;
  wantnulls: boolean;
begin
  {the following escape is necessitated by change in default row height which
   corrupts display of hidden rows in wgProbData. Since the default rowheight
   is changed with each change in screen size, this gets called once before
   PLFilters is created}
  if PLFilters = nil then exit; {not initialized}
  with wgProbData do
    begin
      {show all rows}
      wantnulls := (PLFilters.ProviderList.indexof('-1') > -1);
      for i := 1 to pred(rowcount) do rowheights[i] := defaultrowheight;

      {filter for provider}
      for i := 1 to pred(rowcount) do
        if PLFilters.ProviderList.Count > 0 then
          if PLFilters.ProviderList[0] <> '0' then { 0 signifies all }
            if cells[0,i] <> '' then {don't want to disappear empty rows}
              if (PLFilters.ProviderList.indexof(cells[9,i]) < 0) or
                 ((cells[9,i] = '') and (not wantnulls)) then
                rowheights[i] := 0;

      if PLUser.usCurrentView = PL_UF_VIEW then exit; {Bail out - no filtering by Loc}

      {conditionally filter for clinic(s) - may be multiple selected}
      if PLUser.usCurrentView = PL_OP_VIEW then
        begin
          wantnulls := (PLFilters.ClinicList.indexof('-1') > -1);
          if PLFilters.ClinicList.Count = 0 then exit;
          if PLFilters.ClinicList[0] <> '0' then { 0 signifies all }
            for i := 1 to pred(rowcount) do
              if (cells[0,i] <> '') and                  {don't want to disappear empty rows}
                 (rowheights[i] = defaultrowheight) then {don't want if already filtered}
                 begin
                   {if ((cells[10, i] = '') and
                       (cells[11, i] <> '' )) or
                       (cells[12, i] = PL_WARD) then       {don't want in-patients}
                     {rowheights[i] := 0
                   else}
                   if (cells[10, i] <> '') and       {clinic not on user list}
                           (PLFilters.ClinicList.indexof(cells[10,i]) < 0) then
                     rowheights[i] := 0
                   else if ((cells[10,i] = '') and (not wantnulls)) then {no clinic recorded}
                     rowheights[i] := 0;
                 end;
        end
      else
      {conditionally filter for service - may be multiple selected}
        begin
          wantnulls := (PLFilters.ServiceList.indexof('-1') > -1);
          if PLFilters.ServiceList.Count = 0 then exit;
          if PLFilters.ServiceList[0] <> '0' then { 0 signifies all }
            for i := 1 to pred(rowcount) do
              if (cells[0,i] <> '') and                       {don't want to disappear empty rows}
                (rowheights[i]=defaultrowheight) then         {don't want if already filtered}
                begin
                  {if ((cells[10,i] <> '' )) and
                      (cells[12,i] <> PL_WARD) then            {don't want out-patients}
                    {rowheights[i] := 0
                  else}
                  if (cells[11,i] <> '') and              {Service not on user list}
                          (PLFilters.ServiceList.indexof(cells[11,i]) < 0) then
                    rowheights[i]:=0
                  else if ((cells[11,i] = '') and (not wantnulls)) then               {no Service recorded}
                    rowheights[i]:=0;
                end;
        end;
    end;
end;

procedure TfrmProblems.GetRowCount;
var
  ShownProbs, TotalProbs, i: integer;
begin
  ShownProbs := 0;
  with wgProbData do
    begin
      TotalProbs := rowcount - 5;
      for i := 0 to pred(rowcount) do
        begin
          if (rowheights[i] > 0) and (cells[0,i] <> '') then
            ShownProbs := ShownProbs + 1;
        end;
      case PLUser.usViewAct[1] of
        'A': lblProbList.Caption := ACTIVE_LIST_CAP ;
        'I': lblProbList.Caption := INACTIVE_LIST_CAP ;
        'B': lblProbList.Caption := BOTH_LIST_CAP ;
        'R': lblProbList.Caption := REMOVED_LIST_CAP ;
      end;
    end;
  lblProbList.Caption := lblProbList.Caption + '   (' + IntToStr(ShownProbs) + ' of ' + IntToStr(TotalProbs) + ')';
end;


procedure TfrmProblems.UMPLLexicon(var Message:TMessage);
begin
  if PLProblem = '' then exit; {shouldn't happen but...}
  if dlgProbs = nil then AddProblem;
end;

procedure TfrmProblems.pnlRightResize(Sender: TObject);

  procedure FitGridO(AGrid: TDrawGrid; const AWidth: array of Integer);
  // awidth[i] = 0 for hidden columns
  // awidth[i] = -1 for one (and only one) adjustable column
  var
    i, AdjustCol, cxUsed: Integer;
  begin
    cxUsed := 0;
    AdjustCol := 0;
    with AGrid do
    begin
      for i := 0 to High(AWidth) do
        if AWidth[i] > -1 then
          begin
            if AWidth[i] > 0 then
              begin
                ColWidths[i] := ForChars(AWidth[i], gFontWidth);
                cxUsed := cxUsed + ColWidths[i];
              end;
          end
        else AdjustCol := i;
      ColWidths[AdjustCol] := AGrid.Width - cxUsed;
    end
  end;

begin  {body}
  if PLUser = nil then exit;
  if PLUser.usCurrentView = PL_IP_VIEW then
    begin
      wgProbData.HiddenCols := '0,5,6,9,10,11,12,13,14';
      FitGridO(wgProbData, [0, 5, -1, 9, 9, 0, 0, 12, 12, 0, 0, 0, 0, 0, 0]);
    end
  else if PLUser.usCurrentView = PL_OP_VIEW then
    begin
      wgProbData.HiddenCols := '0,5,7,8,9,10,11,12,13,14';
      FitGridO(wgProbData, [0, 5, -1, 9, 9, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0]);
    end;
  {have to do this to recover hidden rows}
  ApplyViewFilters;
  GetRowCount;
  //PostMessage(frmProblems.Handle, UM_PLFILTER,0,0);
end;

procedure TfrmProblems.FormCreate(Sender: TObject);
begin
  inherited;
  wgProbData.Color := ReadOnlyColor;
  GetFontInfo(Canvas.Handle, gFontWidth, gFontHeight);
end;

procedure TfrmProblems.LoadUserParams(Alist:TstringList);
var
  i: integer;
begin
  AList.Assign(InitUser(User.DUZ)) ;
  //AList.Assign(InitUser(Encounter.Provider)) ;
  PLUser := TPLUserParams.create(Alist);
  FContextString := PLUser.usDefaultContext;
  FFilterString :=  PLUser.usDefaultView + '/';
  if PLFilters <> nil then
    begin
      if PLUser.usDefaultView = 'C' then with PLFilters.ClinicList do
          for i := 0 to Count - 1 do
            if Piece(Strings[i], U, 1) <> '-1' then
              FFilterString := FFilterString + Piece(Strings[i], U, 1) + '/';
      if PLUser.usDefaultView = 'S' then with PLFilters.ServiceList do
          for i := 0 to Count - 1 do
            if Piece(Strings[i], U, 1) <> '-1' then
              FFilterString := FFilterString + Piece(Strings[i], U, 1) + '/';
    end;
  mnuViewComments.Checked := (PLUser.usViewComments = '1');
  if PLUser.usTesting then
    messagedlg('WARNING - Test User Parameters in Effect',mtWarning,[mbOK],0)  ;
  pnlRightResize(Self);
end;

procedure TfrmProblems.LoadPatientParams(AList:TstringList);
begin
  AList.Assign(InitPt(Patient.DFN)) ;
  PLPt := TPLPt.create(Alist);
end;

procedure TfrmProblems.ClearGrid;
var
  i:integer;
begin
  with wgprobdata do for i := 0 to pred(rowcount) do
    begin
      if Objects[2, i] <> nil then
        begin
          TStringList(Objects[2, i]).Free;
          Objects[2, i] := nil;
        end;
      rows[i].clear;
      rowheights[i] := defaultrowheight; {restore any disappeared}
    end;
  wgprobdata.rowcount := 5;
end;


procedure TfrmProblems.LoadPatientProblems(AList:TStringList; const Status:char; init:boolean);
var {init should only be true when initializing a list for a new patient}
  x, ver, prio, comments: string;
  i, j: Integer;
  st: char;
  CmtList: TStringList;
  //SCCond, tmpSCstr: string;

  procedure ReverseList(Alist:TstringList);
  var
    i,j:integer;
  begin
    i:=0;
    j:=pred(Alist.count);
    while i<j do
      begin
        alist.exchange(i,j);
        inc(i);
        dec(j);
      end;
  end;

begin  {Body}
  CmtList := TStringList.Create;
  if PLFilters=nil then {create view filter lists}
    PLFilters:=TPLFilters.create;
  try
    ClearGrid;
    if PLPt = nil then
      begin
        InfoBox(TX_INVALID_PATIENT, TC_NO_PATIENT, MB_OK or MB_ICONWARNING);
        AList.Clear;
        AList.Add('No data available');
      end
    else
      begin
        st:=status;
        if st= '' then st := 'A'; {default to active list}
        AList.Assign(ProblemList(Patient.DFN,St)) ;
      end;
    if Status = 'R' then
      wgProbData.HiddenCols := '0,1,5,9,10,11,12,13,14'
    else
      wgProbData.HiddenCols := '0,5,9,10,11,12,13,14';
    if Alist.count > 1 then Alist.delete(0); {get rid of first element - it is a list count}
    SortByPiece(AList, u, 6); { Sort by FM date/time }
    SetListFMDateTime('MMM dd yyyy',AList, u, 6);      { Change FM date to MM/DD/YY  }
    SetListFMDateTime('MMM dd yyyy',AList, u, 5);      { Change FM date to MM/DD/YY  }
    if PLUser.usReverseChronDisplay then {reverse chron order if required}
      ReverseList(Alist);
    {populate the grid}
    if ((Alist.Count = 1) and (pos('No data available', Alist[0]) > 0))then
      begin
        wgProbData.cells[2,1] := 'No problems found.';
        Alist.Clear ;
        NoRowSelected;
        exit ;
      end ;
    with wgProbData do
      begin
        rowcount:=Alist.count+5;
        cells[1,0]  := 'Stat/Ver';
        cells[2,0]  := 'Description';
        cells[3,0]  := 'Onset Date';
        cells[4,0]  := 'Last Updated';
        cells[6,0]  := 'Location';
        cells[7,0]  := 'Provider';
        cells[8,0]  := 'Service';
        for i := 0 to pred(Alist.count) do
          begin
            comments := '';
            CmtList.Clear;
            x := AList[i];
            if (PlUSer.usVerifyTranscribed) and
               //(PlUser.usPrimeUser) and            //  comment out this line so ALL users see (u) ?
               (Piece(x, U, 9) = 'T') then
              ver := '(u)'
            else
              ver := '   ';
            if Piece(x, U, 14) = 'A' then prio   := ' * ' else prio   := '   ' ;
            cells[1,succ(i)] := Piece(x, U, 2) + prio + ver;
            if Piece(x, U, 15) = '1' then  //problem has comments
              begin
                CmtList.Assign(GetProblemComments(Piece(x, U, 1)));
                if Objects[2,succ(i)] = nil then Objects[2,succ(i)]:= TStringList.Create;
                TStringList(Objects[2,succ(i)]).Assign(CmtList);
              end;

            // get service-connected and exposures for grid display (v20 - RV)
(*            tmpSCstr := Piece(x, U, 17);
            SCCond := '';
            if Copy(tmpSCStr, 1, 1) = '/' then tmpSCStr := Copy(tmpSCStr, 2, MaxInt);
            if Copy(tmpSCStr, 1, 3) = 'NSC' then tmpSCStr := Copy(tmpSCStr, 5, MaxInt);
            if Length(tmpSCStr) > 0 then SCCond := '(' + tmpSCStr + ')';*)

            cells[2,succ(i)] := Piece(x, U, 3);
            //if SCCond <> '' then cells[2,succ(i)] := cells[2,succ(i)] + '  ' + SCCond;
            if PLUser.usViewComments = '1' then
              begin
                for j := 0 to CmtList.Count-1 do
                  comments := comments + '         ' + CmtList.Strings[j] + #13#10;
                cells[2,succ(i)] := cells[2,succ(i)] + #13#10 + comments;
              end;
            cells[3,succ(i)]   := Trim(Piece(x, U, 5));                              {onset date}
            cells[4,succ(i)]   := Trim(Piece(x, U, 6));                              {last updated}
            cells[6,succ(i)]   := MixedCase(Piece(Piece(x, U, 10), ';', 2));   {location name}
            cells[7,succ(i)]  := MixedCase(Piece(Piece(x, U, 12), ';', 2));   {provider name}
            cells[8,succ(i)]  := MixedCase(Piece(Piece(x, U, 13), ';', 2));   {service name}
            {hidden cells}
            cells[0,succ(i)]   := Piece(x, U, 1);                              {problem IEN}
            cells[5,succ(i)]   := Piece(x, U, 7);                              {service connected status}
            cells[10,succ(i)]   := Piece(Piece(x, U, 10), ';', 1);              {location IEN}
            cells[12,succ(i)]   := Piece(x, U, 11);                             {loc type}
            cells[9,succ(i)]   := Piece(Piece(x, U, 12), ';', 1);              {responsible provider IEN}
            cells[11,succ(i)]  := Piece(Piece(x, U, 13), ';', 1);              {service IEN}
            cells[13,succ(i)]  := Piece(x, U, 4);                              {code}
            cells[14,succ(i)]  := Piece(x, U, 17);                             {Service-connected conditions}
          end;
      end;
      Alist.clear;
      if not init then
        SetViewFilters(Alist)
      else
        InitViewFilters(Alist);
      ApplyViewFilters;
      lstProbPick.ItemIndex := -1;
      NoRowSelected ;
      if (ProbRec <> nil) and (ProbRec.PIFN <> '') then
        begin
          for i := 0 to wgProbData.Rowcount-1 do
            if (wgProbData.Cells[0, i] = ProbRec.PIFN) and (wgProbData.rowheights[i] > 0) then
               wgProbData.Row := i ;
          wgProbDataClick(Self);
          RowSelected;
        end
      else
        begin
          wgProbData.Row := 1;
          RowSelected;
        end;
      pnlRightResize(Self);
      //GetRowCount;
  finally
    CmtList.Free;
  end;
end;

procedure TfrmProblems.LoadUserCats(AList:TStringList);
begin
  if not PLUser.usUseLexicon then exit; {Bail out if not to use lexicon}
  Alist.clear;
  AList.Assign(UserProblemCategories(Encounter.Provider,Encounter.Location)) ;
  if Alist.count = 0 then
    begin
      lstCatPick.Items.Add('-1^None defined - use OTHER') ;
      lstProbPick.Visible := False ;
      lblProblems.Visible := False ;
      exit ;
    end ;
  lstCatPick.items.assign(AList);
  lstCatPick.itemindex := 0;
  lstCatPickClick(frmProblems);
end;

procedure TfrmProblems.LoadUserProbs(AList:TStringList);
var
  catien: string;
begin
  if not PLUser.usUseLexicon then exit; {Bail out if not to use lexicon}
  if lstCatPick.itemindex < 0 then exit; {bail out}
  Alist.clear;
  catien := IntToStr(lstCatPick.itemIEN);
  AList.Assign(UserProblemList(catien)) ;
  {File 125.12, Each line contains: PROBLEM^DISPLAY TEXT^CODE^CODE IFN }
  {code ifn is derived}
  lstProbPick.items.assign(Alist);
end;

procedure TfrmProblems.LoadProblems;
var
  AList: TStringList;
  i: integer;
begin
  pProviderID := 0;
  AList := TStringList.Create;
  try
    lstView.ItemIndex := -1;
    StatusText('Retrieving problem list...') ;
    if (PLUser = nil) or InitPatient then LoadUserParams(Alist);
    Alist.clear;
    if Patient.DFN <> '' then LoadPatientParams(Alist);
    Alist.clear;
    LoadPatientProblems(AList,PlUser.usViewAct[1],true); {initialize patient list}
    lstView.ItemIndex := -1;
    AList.clear;
    lstCatPick.Clear ;
    LoadUserCats(AList);
    {SET APPLICATION DEFAULTS}
    if (not PLUser.usPrimeUser) then
      begin {activities available to GMPLUSER only}
        mnuActRestore.enabled := False;
        mnuActRemove.enabled:=false;
        mnuViewRemoved.Enabled := False;
        popRemove.enabled:=false;
        popRestore.enabled := False;
        i := lstView.Items.IndexOf('Removed');
        if i > -1 then lstView.Items.Delete(i);
        mnuActVerify.enabled:=false;
        popVerify.enabled:=false;
      end;
    if (not PLUser.usVerifyTranscribed) then
      begin
        mnuActVerify.enabled:=false;
        popVerify.enabled:=false;
      end;
  finally
    AList.Free;
    StatusText('') ;
  end;
end;

procedure TfrmProblems.AddProblem;
var
  newprob, dup: string;
  cmplist: TstringList;
  cmpp, msgRslt, i: integer;
  collapserow: boolean;
begin
  if (PLPt.ptDead<>'') then {Check for dead patient}
    if messagedlg('This Patient has been deceased since ' + PLPt.ptDead + #13#10 +
    '        Proceed with problem addition?', mtConfirmation,[mbYes,mbNo],0) = mrNO then
      exit; {bail out - if don't want to add to dead}
  {problems are in the form of: ien^.01^icd^icdifn , although only the .01 is required}
  if PLProblem <> '' then 
    begin                 
      newProb:=PLProblem; 
      PLProblem:='';       
    end
  else if edProbEnt.text<>'' then
    begin
      newprob:= u + edProbEnt.text + u + u; {free text problem entry from editbox}
      edProbEnt.Visible := False;
      lblProbEnt.Visible := False;
      edProbEnt.Text := '';
    end
  else if lstProbPick.itemindex > -1 then {problem selected from user list}
    {Each line contains: PROBLEM^DISPLAY TEXT^CODE^CODE IFN }
    newprob:=lstProbPick.items[lstProbPick.itemindex];
  if NewProb='' then exit; {should never happen}
  bbCancel.Enabled := False ;
  bbOtherProb.enabled:=false; {don't let them invoke lexicon till add completed}

  //  =============  new duplicate checking code  ===================
  if Piece(newprob, U, 1) = '' then
    dup := CheckForDuplicateProblem('1', Piece(newprob, U, 2))
  else
    dup := CheckForDuplicateProblem(Piece(newprob,U,1), Piece(newprob, U, 2));
  if Piece(dup, U, 1) <> '0' then
    begin
      if (Piece(dup, U, 2) <> PLUser.usViewAct) and (PLUser.usViewAct <> 'B') then
        begin
          lstView.SelectByID(Piece(dup, U, 2));
          lstViewClick(Self);
        end;
      cmplist:=Tstringlist.create;
      try {find and highlight duplicate problem - match problem text minus trailing '*'}
        for i := 0 to wgProbData.RowCount - 1 do
          cmpList.Add(TrimRight(Piece(Piece(wgProbData.Cells[2,i], #13, 1), '*', 1)));
        cmpp:=cmpList.indexof(TrimRight(Piece(Piece(newprob, U, 2), '*', 1)));
      finally
        cmplist.free;
      end;
      if cmpp > -1 then
        begin
          collapserow:=false;
          if wgProbData.rowheights[cmpp]=0 then
            begin {handle case of duplicate hidden by filtering}
              wgProbData.rowHeights[cmpp]:=wgProbData.defaultRowHeight;
              collapserow:=true;
            end;
          wgProbData.row:=cmpp;
          msgRslt := messagedlg('This problem is a duplicate of the highlighted problem'
                 + #13#10 + '        Proceed?', mtConfirmation,[mbYes,mbNo],0);
          if collapserow then wgProbData.rowHeights[cmpp] := 0;
          if msgRslt = mrNO then
            begin
              bbCancel.Enabled := True ;
              bbOtherProb.enabled:=true; {don't let them invoke lexicon till add completed}
              exit; {bail out - if don't want dups}
            end ;
        end;
    end;
//============================== End new code =========================
  if ProbRec = nil then
    begin
      pnlRight.Caption := lblProbList.caption ;
      lblProbList.caption:='Add Problem';
      pnlProbDlg.Visible := True;
      pnlProbDlg.BringToFront ;
      dlgProbs:=TFrmDlgProb.create(pnlProbDlg);
      dlgProbs.parent:=pnlProbDlg;
      dlgProbs.Font:=font;
      dlgProbs.Align := alClient ;
      dlgProbs.Reason:='A';
      dlgProbs.SubjProb:=newprob;
      dlgProbs.show;
      PostMessage(dlgProbs.Handle, UM_TAKEFOCUS, 0, 0);
    end
  else
    messagedlg('Current Add/Edit/Display activity must be completed' + #13#10 +
              'before another record may be added', mtInformation,[mbOK],0);
end;

procedure TfrmProblems.EditProblem(const why: char);
var
  prob: string;
  reas: string;
begin
  prob := wgProbData.cells[0, wgProbData.row];
  if (prob <> '') and (ProbRec = nil) then
    begin
      StatusText('Retrieving selected problem...') ;
      bbCancel.Enabled := False ;
      bbOtherProb.enabled := false; {don't let them invoke lexicon till edit completed}
      case why of
        'E','e','C','c' : reas := 'Edit Problem';
        'D','d'         : reas := 'Display Problem';
        'R','r'         : reas := 'Remove Problem';
      end;
      pnlRight.Caption   := lblProbList.caption ;
      lblProbList.caption     := reas;
      pnlProbDlg.Visible := True;
      pnlProbDlg.BringToFront ;
      dlgProbs           := TFrmDlgProb.create(pnlProbDlg);
      dlgProbs.parent    := pnlProbDlg;
      dlgProbs.Font      := font;
      dlgProbs.Align     := alClient ;
      dlgProbs.Reason    := why;
      with wgProbData do dlgProbs.subjProb:=prob + u + Piece(cells[2,row], #13, 1) + u + cells[13,row];
      StatusText('') ;
      dlgProbs.Show;
      PostMessage(dlgProbs.Handle, UM_TAKEFOCUS, 0, 0);
    end
  else
    begin
      case why of
        'E','e','C','c' : reas := 'Edited';
        'D','d'         : reas := 'Displayed';
        'R','r'         : reas := 'Removed';
      end;
      messagedlg('Current Add/Edit/Display activity must be completed' + #13#10 +
        'before another record may be ' + reas, mtInformation,[mbOK],0);
    end;
end;

procedure TfrmProblems.UpdateProblem(const why:char);
var
  Alist: TstringList;
  ProblemIFN: string;
  sv: string;
  i: integer;
begin
  alist := TstringList.create;
  try
    problemIFN := wgProbData.cells[0,wgProbData.row];
    {get the basic info - could shortcut, but try this for now}
    AList.Assign(EditLoad(ProblemIFN,pProviderID,PLPt.ptVAMC)) ;
    probRec := TProbrec.create(Alist);
    probRec.PIFN := problemIFN;
    ProbRec.RespProvider.DHCPtoKeyVal(inttostr(Encounter.Provider) + u + Encounter.ProviderName);   {REV - V13}
    Alist.clear;
    case why of
      'I': begin
             ProbRec.status := 'I';
             {assume resolution date now with this option. user should do full edit otherwise}
             ProbRec.DateResStr := 'T';
             Probrec.DateModStr := 'T';
             AList.Assign(ProblemUpdate(ProbRec.AltFilerObject)) ;
           end;
      'V': begin
             Probrec.condition := 'P';
             Probrec.DateModStr := 'T';
             AList.Assign(ProblemVerify(ProbRec.PIFN)) ;
           end;
    end;

    if Alist.count<1 then {show error message}
      messagedlg('Unable to update record ',mtInformation,[mbOK],0)
    else if Alist[0]<'1' then
      messagedlg('Unable to update record: ' + #13#10 + ' ' + Alist[1] + ' (' + Probrec.PIFN + ')',
                 mtInformation,[mbOK],0)
    else {show inactivated problem}
      if (why='I') then
        begin
          if (PlUser.usViewAct='A') then
            begin
              wgProbData.rowheights[wgProbData.row]:=0 {disappear Inactive row} ;
              AList.Clear ;
              LoadPatientProblems(Alist,'A',False) ;
              NoRowSelected ;
            end
          else
            wgProbData.cells[1,wgProbData.row]:='I';
        end
    else if (why='V') then {show verified problem}
      begin
        sv := wgProbData.cells[1,wgProbData.row];
        wgProbData.cells[1,wgProbData.row] := Copy(sv,1,4); //remove (u)
        mnuActVerify.Enabled := False;
        popVerify.Enabled := False;
      end;
  finally
    with frmCover do
      for i := ComponentCount - 1 downto 0 do
        begin
          if Components[i] is TORListBox then
            begin
              case Components[i].Tag of
                10: ListActiveProblems((Components[i] as TORListBox).Items);
              end;
            end;
        end;
    alist.free;
    ProbRec.free;
    ProbRec := nil;
  end;
end;

procedure TfrmProblems.RestoreProblem;
var
  Alist:TstringList;
  ProblemIFN:string;
  i: integer;
begin
  Alist := TStringList.create;
  try
    problemIFN := wgProbData.cells[0,wgProbData.row];
    Alist.Assign(ProblemReplace(ProblemIFN)) ;
    if Alist[0] <> '1' then
      messagedlg('Unable to restore the problem record: ' + #13#10 + ' (' + Probrec.PIFN + ')',
                 mtInformation,[mbOK],0)
    else
      LoadPatientProblems(AList, 'R', False);
    GetRowCount;
  finally
    with frmCover do
      for i := ComponentCount - 1 downto 0 do
        begin
          if Components[i] is TORListBox then
            begin
              case Components[i].Tag of
                10: ListActiveProblems((Components[i] as TORListBox).Items);
              end;
            end;
        end;
    Alist.free;
  end;
end;

procedure TfrmProblems.NoRowSelected;
begin
  mnuActDetails.enabled    := false;
  mnuActChange.enabled     := false;
  mnuActVerify.enabled     := false;
  mnuActInactivate.enabled := false;
  mnuActRestore.enabled    := false;
  mnuActRemove.enabled     := false;
  mnuActAnnotate.enabled   := false;
  popChange.enabled        := false;
  popVerify.enabled        := false;
  popInactivate.enabled    := false;
  popRestore.enabled       := false;
  popRemove.enabled        := false;
  popAnnotate.enabled      := false;
  popViewDetails.enabled   := False;
end ;

procedure TfrmProblems.RowSelected;
begin
  mnuActDetails.enabled    := true;
  mnuActChange.enabled     := true;
  mnuActVerify.enabled     := PLUser.usVerifyTranscribed and
                              PLUser.usPrimeUser and
                             (Copy(wgProbData.cells[1,wgProbData.row],5,3)='(u)') ;
  mnuActInactivate.enabled := Copy(wgProbData.cells[1,wgProbData.row],1,1) = 'A' ;
  mnuActRestore.enabled    := PLUser.usPrimeUser;
  mnuActRemove.enabled     := PLUser.usPrimeUser;
  mnuActAnnotate.enabled   := true;
  popChange.enabled        := true;
  popVerify.enabled        := PLUser.usVerifyTranscribed and
                              PLUser.usPrimeUser and
                             (Copy(wgProbData.cells[1,wgProbData.row],5,3)='(u)') ;
  popInactivate.enabled    := Copy(wgProbData.cells[1,wgProbData.row],1,1) = 'A' ;
  popRestore.enabled       := PLUser.usPrimeUser;
  popRemove.enabled        := PLUser.usPrimeUser;
  popAnnotate.enabled      := true;
  popViewDetails.enabled   := true ;
end ;

procedure TfrmProblems.bbCancelClick(Sender: TObject);
begin
  inherited;
  pnlView.BringToFront ;
  pnlView.Show ;
  pnlButtons.Hide;
  pnlButtons.SendToBack;
end;

procedure TfrmProblems.lstViewClick(Sender: TObject);
begin
  inherited;
  case lstView.ItemIndex of
    0:  tag := 700 ;      {Active}
    1:  tag := 800 ;      {Inactive}
    2:  tag := 900 ;      {Both}
    3:  tag := 950 ;      {Removed}
{       4:  tag := 975 ;      {Filters...}
  end ;
  lstProbActsClick(Self) ;
end;

function EncounterPresent: Boolean;
{ make sure a location and provider are selected, returns false if not }
begin
  Result := True;
  if (Encounter.Provider = 0) or (Encounter.Location = 0) then
  begin
    UpdateEncounter(NPF_ALL);  {*KCM*}
    frmFrame.DisplayEncounterText;
  end;
  if (Encounter.Provider = 0) or (Encounter.Location = 0) then
  begin
    InfoBox(TX_PROV_LOC, TC_PROV_LOC, MB_OK or MB_ICONWARNING);  {!!!}
    Result := False;
  end;
end;

procedure TfrmProblems.FormDestroy(Sender: TObject);
var
  i: integer;
begin
  with wgProbData do for i := 0 to RowCount - 1 do
    if Objects[2, i] <> nil then
      begin
        TStringList(Objects[2, i]).Free;
        Objects[2, i] := nil;
      end;
  inherited;
end;

procedure TfrmProblems.mnuViewSaveClick(Sender: TObject);
begin
  inherited;
  if PLPt = nil then
    begin
      InfoBox(TX_INVALID_PATIENT, TC_NO_PATIENT, MB_OK or MB_ICONWARNING);
      Exit;
    end;
  if MessageDlg('Replace current defaults?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      with PLUser do
        begin
          usDefaultContext := FContextString;
          usDefaultView    := Piece(FFilterString, '/', 1);
        end;
      SaveViewPreferences(FFilterString + U + FContextString);
    end;
end;

procedure TfrmProblems.mnuViewRestoreDefaultClick(Sender: TObject);
begin
  inherited;
  if PLPt = nil then
    begin
      InfoBox(TX_INVALID_PATIENT, TC_NO_PATIENT, MB_OK or MB_ICONWARNING);
      Exit;
    end;
  if PLFilters <> nil then
    begin
      PLFilters.Destroy;
      PLFilters := nil;
    end;
  if PLUser <> nil then
    begin
      PLUser.Destroy;
      PLUser := nil;
    end;
  pnlView.BringToFront ;
  pnlView.Show ;
  LoadProblems ;
end;

procedure TfrmProblems.mnuViewCommentsClick(Sender: TObject);
var
  x, comments: string;
  i, j: integer;
begin
  inherited;
  if PLPt = nil then
    begin
      InfoBox(TX_INVALID_PATIENT, TC_NO_PATIENT, MB_OK or MB_ICONWARNING);
      Exit;
    end;
  mnuViewComments.Checked := not mnuViewComments.Checked;
  SetPiece(FContextString, ';', 4, BOOLCHAR[mnuViewComments.Checked]);
  PLUser.usViewComments := BOOLCHAR[mnuViewComments.Checked];
  with wgProbData do
    begin
      for i := 0 to RowCount - 1 do
        begin
          if Objects[2, i] = nil then continue;
          x := Piece(Cells[2, i], #13, 1);
          if PLUser.usViewComments = '1' then
            begin
              comments := '';
              for j := 0 to TStringList(Objects[2, i]).Count - 1 do
                comments := comments + '         ' + TStringList(Objects[2, i]).Strings[j] + #13#10;
                //comments := comments + '   CMT:  ' + TStringList(Objects[2, i]).Strings[j] + #13#10;
              cells[2, i] := x + #13#10 + comments;
            end
          else
            cells[2, i] := x;
        end;
    end;
end;

procedure TfrmProblems.RequestPrint;
begin
  inherited;
  if PLPt = nil then
    begin
      InfoBox(TX_INVALID_PATIENT, TC_NO_PATIENT, MB_OK or MB_ICONWARNING);
      Exit;
    end;
  uReportType := '';
  PrintReports(IntToStr(RPT_PROBLIST), 'Problem List')
end;

end.


